/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class Distributor extends Script {
  double start_time = 0.0;
  double time = 0.0;
  double last_time = 0.0;
  double fraction = 0.0;
  boolean Octopus1_visible = true;
  public void processEvent( Event e ) {
    String name = e.getName();
    if ( "cycleTime".equals( name ) ) {
      time = ((ConstSFTime)e.getValue()).getValue();
      fraction = 0.0;
      if ( start_time == 0.0 )
        start_time = time;
    } else if ( "Octopus1Visible".equals(name) ) {
      Octopus1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "fraction_changed".equals( name ) )
      fraction = (double)((ConstSFFloat)e.getValue()).getValue();
  }
  public void eventsProcessed() {
    if ( time + fraction - start_time <= last_time )
        return;
    last_time = time + fraction - start_time;
    if ( Octopus1_visible )
      ((SFFloat)getEventOut("Octopus1CurrentTime")).setValue((float)last_time);
  }
}
