/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.field.*;
import vrml.node.*;
import berkeley.cs.dmc.system.DynamicsVariable;

public class Octopus extends Script {
  double time = 0.0;
  double last_time = 0.0;
  boolean initialized = false;
  double[] old_params = new double[2];
  double[] seen_params = new double[2];
  double[] new_params = new double[2];
  private OctopusCarVariable carsix = null;
  private MFFloat carsix_buffer = null;
  private SFFloat carsix_lastTime = null;
  private SFFloat carsix_lastSeen = null;
  private float[] carsix_elements = new float[1];
  private boolean carsix_visible = true;
  private OctopusCarVariable carone = null;
  private MFFloat carone_buffer = null;
  private SFFloat carone_lastTime = null;
  private SFFloat carone_lastSeen = null;
  private float[] carone_elements = new float[1];
  private boolean carone_visible = true;
  private OctopusCarVariable carseven = null;
  private MFFloat carseven_buffer = null;
  private SFFloat carseven_lastTime = null;
  private SFFloat carseven_lastSeen = null;
  private float[] carseven_elements = new float[1];
  private boolean carseven_visible = true;
  private OctopusCarVariable carfive = null;
  private MFFloat carfive_buffer = null;
  private SFFloat carfive_lastTime = null;
  private SFFloat carfive_lastSeen = null;
  private float[] carfive_elements = new float[1];
  private boolean carfive_visible = true;
  private OctopusClosedVars octopusclosed = null;
  private MFFloat octopusclosed_buffer = null;
  private SFFloat octopusclosed_lastTime = null;
  private SFFloat octopusclosed_lastSeen = null;
  private float[] octopusclosed_elements = new float[2];
  private boolean octopusclosed_visible = true;
  private OctopusCarVariable cartwo = null;
  private MFFloat cartwo_buffer = null;
  private SFFloat cartwo_lastTime = null;
  private SFFloat cartwo_lastSeen = null;
  private float[] cartwo_elements = new float[1];
  private boolean cartwo_visible = true;
  private OctopusCarVariable carfour = null;
  private MFFloat carfour_buffer = null;
  private SFFloat carfour_lastTime = null;
  private SFFloat carfour_lastSeen = null;
  private float[] carfour_elements = new float[1];
  private boolean carfour_visible = true;
  private OctopusCarVariable careight = null;
  private MFFloat careight_buffer = null;
  private SFFloat careight_lastTime = null;
  private SFFloat careight_lastSeen = null;
  private float[] careight_elements = new float[1];
  private boolean careight_visible = true;
  private OctopusCarVariable carthree = null;
  private MFFloat carthree_buffer = null;
  private SFFloat carthree_lastTime = null;
  private SFFloat carthree_lastSeen = null;
  private float[] carthree_elements = new float[1];
  private boolean carthree_visible = true;
  private SFRotation CarOneR_event = null;
  private SFRotation CarFiveR_event = null;
  private SFRotation SecBeam4_event = null;
  private SFRotation SecBeam3_event = null;
  private SFRotation SecBeam2_event = null;
  private SFRotation SecBeam1_event = null;
  private SFRotation CarSevenR_event = null;
  private SFRotation CarThreeR_event = null;
  private SFRotation CarSixR_event = null;
  private SFRotation CarEightR_event = null;
  private SFRotation CarTwoR_event = null;
  private SFRotation CarFourR_event = null;
  private SFRotation MainRotate_event = null;
  public void initialize() {
    if ( initialized ) return;
    carsix = new OctopusCarVariable();    carsix_buffer = (MFFloat)getField("carsix_buffer");
    carsix_lastTime = (SFFloat)getField("carsix_lastTime");
    carsix_lastSeen = (SFFloat)getField("carsix_lastSeen");
    carone = new OctopusCarVariable();    carone_buffer = (MFFloat)getField("carone_buffer");
    carone_lastTime = (SFFloat)getField("carone_lastTime");
    carone_lastSeen = (SFFloat)getField("carone_lastSeen");
    carseven = new OctopusCarVariable();    carseven_buffer = (MFFloat)getField("carseven_buffer");
    carseven_lastTime = (SFFloat)getField("carseven_lastTime");
    carseven_lastSeen = (SFFloat)getField("carseven_lastSeen");
    carfive = new OctopusCarVariable();    carfive_buffer = (MFFloat)getField("carfive_buffer");
    carfive_lastTime = (SFFloat)getField("carfive_lastTime");
    carfive_lastSeen = (SFFloat)getField("carfive_lastSeen");
    octopusclosed = new OctopusClosedVars();    octopusclosed_buffer = (MFFloat)getField("octopusclosed_buffer");
    octopusclosed_lastTime = (SFFloat)getField("octopusclosed_lastTime");
    octopusclosed_lastSeen = (SFFloat)getField("octopusclosed_lastSeen");
    cartwo = new OctopusCarVariable();    cartwo_buffer = (MFFloat)getField("cartwo_buffer");
    cartwo_lastTime = (SFFloat)getField("cartwo_lastTime");
    cartwo_lastSeen = (SFFloat)getField("cartwo_lastSeen");
    carfour = new OctopusCarVariable();    carfour_buffer = (MFFloat)getField("carfour_buffer");
    carfour_lastTime = (SFFloat)getField("carfour_lastTime");
    carfour_lastSeen = (SFFloat)getField("carfour_lastSeen");
    careight = new OctopusCarVariable();    careight_buffer = (MFFloat)getField("careight_buffer");
    careight_lastTime = (SFFloat)getField("careight_lastTime");
    careight_lastSeen = (SFFloat)getField("careight_lastSeen");
    carthree = new OctopusCarVariable();    carthree_buffer = (MFFloat)getField("carthree_buffer");
    carthree_lastTime = (SFFloat)getField("carthree_lastTime");
    carthree_lastSeen = (SFFloat)getField("carthree_lastSeen");
    CarOneR_event = (SFRotation)getEventOut("CarOneR");
    CarFiveR_event = (SFRotation)getEventOut("CarFiveR");
    SecBeam4_event = (SFRotation)getEventOut("SecBeam4");
    SecBeam3_event = (SFRotation)getEventOut("SecBeam3");
    SecBeam2_event = (SFRotation)getEventOut("SecBeam2");
    SecBeam1_event = (SFRotation)getEventOut("SecBeam1");
    CarSevenR_event = (SFRotation)getEventOut("CarSevenR");
    CarThreeR_event = (SFRotation)getEventOut("CarThreeR");
    CarSixR_event = (SFRotation)getEventOut("CarSixR");
    CarEightR_event = (SFRotation)getEventOut("CarEightR");
    CarTwoR_event = (SFRotation)getEventOut("CarTwoR");
    CarFourR_event = (SFRotation)getEventOut("CarFourR");
    MainRotate_event = (SFRotation)getEventOut("MainRotate");
    initialized = true;
  }
  public void processEvent( Event e ) {
    String name = e.getName();
    if ( "currentTime".equals( name ) ) {
      time=((ConstSFFloat)e.getValue()).getValue();
    } else if ( "OctopusBound".equals( name ) ) {
      octopusclosed_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
      ((SFBool)getEventOut("visible")).setValue(octopusclosed_visible);
    } else if ( "CarOneBound".equals( name ) ) {
      carone_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarTwoBound".equals( name ) ) {
      cartwo_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarThreeBound".equals( name ) ) {
      carthree_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarFourBound".equals( name ) ) {
      carfour_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarFiveBound".equals( name ) ) {
      carfive_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarSixBound".equals( name ) ) {
      carsix_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarSevenBound".equals( name ) ) {
      carseven_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CarEightBound".equals( name ) ) {
      careight_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    }
  }
  private void timeStep(MFFloat buffer, SFFloat lastTime,
                        SFFloat lastSeen, double bufStep, double phase,
                        DynamicsVariable var, double time, float[] fields,
                        int num_p, int num_b) {
    time += phase;

    double last_time = (double)lastTime.getValue();
    double last_seen = (double)lastSeen.getValue();

    if ( num_b == 1 )
    {
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = (double)buffer.get1Value(i);
      var.newState(last_time, old_params,
                   last_time, old_params,
                   time, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(i, (float)new_params[i]);
      lastTime.setValue((float)time);
      var.evaluateFields(time, new_params, fields);
      return;
    }

    int    low_index = (int)Math.floor(time / bufStep);
    double low_time = low_index * bufStep;
    int    high_index = ( low_index + 1 ) % num_b;
    int    last_index = (int)Math.floor((last_time + 0.001) / bufStep) % num_b;
    int    seen_index = (int)Math.floor((last_seen + 0.001) / bufStep) % num_b;

    float work_done = 0.0f;

    int base = 0;

    low_index = low_index % num_b;

    base = last_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      old_params[i] = (double)buffer.get1Value(base + i);
    base = seen_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      seen_params[i] = (double)buffer.get1Value(base + i);

    if ( low_time >= last_time )
    {
      work_done = var.newState(last_time, old_params,
                               last_seen, seen_params,
                               time, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      base = low_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time = low_time;
      last_index = low_index;
    }
    if ( low_time + bufStep > last_time )
    {
      work_done += var.newState(low_time, old_params,
                                last_seen, seen_params,
                                low_time + bufStep, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      base = high_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time = low_time + bufStep;
      last_index = high_index;
    }


    // Guaranteed to have low and high time buffer positions filled.
    int slots_used = last_index - low_index + 1;
    if ( slots_used < 1 )
      slots_used += num_b;
    base = 0;
    while (  work_done < 1.0f && slots_used < num_b )
    {
      work_done += var.newState(last_time, old_params,
                                last_seen, seen_params,
                                last_time + bufStep, new_params);
      last_index = ( last_index + 1 ) % num_b;
      base = last_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time += bufStep;
      slots_used++;
    }

    lastTime.setValue((float)last_time);
    lastSeen.setValue((float)(low_time + bufStep));

    double fraction = ( time - low_time ) / bufStep;
    int base1 = high_index * num_p;
    base = low_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      new_params[i] = fraction * buffer.get1Value(base1 + i)
                    + ( 1.0 - fraction ) * buffer.get1Value(base + i);
    var.evaluateFields(time, new_params, fields);
  }
  public void eventsProcessed() {
    if ( ! initialized ) return;
    if ( time <= last_time )
        return;
    last_time = time;
    if ( carsix_visible )
      timeStep(carsix_buffer, carsix_lastTime, carsix_lastSeen, 0.1f, 7.5f, carsix, last_time, carsix_elements, 2, 200);
    if ( carone_visible )
      timeStep(carone_buffer, carone_lastTime, carone_lastSeen, 0.1f, 0.0f, carone, last_time, carone_elements, 2, 200);
    if ( carseven_visible )
      timeStep(carseven_buffer, carseven_lastTime, carseven_lastSeen, 0.1f, 0.0f, carseven, last_time, carseven_elements, 2, 200);
    if ( carfive_visible )
      timeStep(carfive_buffer, carfive_lastTime, carfive_lastSeen, 0.1f, 0.0f, carfive, last_time, carfive_elements, 2, 200);
    if ( octopusclosed_visible )
      timeStep(octopusclosed_buffer, octopusclosed_lastTime, octopusclosed_lastSeen, 0.01f, 0.0f, octopusclosed, last_time, octopusclosed_elements, 2, 1);
    if ( cartwo_visible )
      timeStep(cartwo_buffer, cartwo_lastTime, cartwo_lastSeen, 0.1f, 7.5f, cartwo, last_time, cartwo_elements, 2, 200);
    if ( carfour_visible )
      timeStep(carfour_buffer, carfour_lastTime, carfour_lastSeen, 0.1f, 7.5f, carfour, last_time, carfour_elements, 2, 200);
    if ( careight_visible )
      timeStep(careight_buffer, careight_lastTime, careight_lastSeen, 0.1f, 7.5f, careight, last_time, careight_elements, 2, 200);
    if ( carthree_visible )
      timeStep(carthree_buffer, carthree_lastTime, carthree_lastSeen, 0.1f, 0.0f, carthree, last_time, carthree_elements, 2, 200);
    if ( carone_visible )
      CarOneR_event.setValue(0.0f, 0.0f, 1.0f, carone_elements[0]);
    if ( carfive_visible )
      CarFiveR_event.setValue(0.0f, 0.0f, 1.0f, carfive_elements[0]);
    if ( octopusclosed_visible )
      SecBeam4_event.setValue(0.0f, 0.0f, 1.0f, octopusclosed_elements[1]);
    if ( octopusclosed_visible )
      SecBeam3_event.setValue(0.0f, 0.0f, 1.0f, octopusclosed_elements[1]);
    if ( octopusclosed_visible )
      SecBeam2_event.setValue(0.0f, 0.0f, 1.0f, octopusclosed_elements[1]);
    if ( octopusclosed_visible )
      SecBeam1_event.setValue(0.0f, 0.0f, 1.0f, octopusclosed_elements[1]);
    if ( carseven_visible )
      CarSevenR_event.setValue(0.0f, 0.0f, 1.0f, carseven_elements[0]);
    if ( carthree_visible )
      CarThreeR_event.setValue(0.0f, 0.0f, 1.0f, carthree_elements[0]);
    if ( carsix_visible )
      CarSixR_event.setValue(0.0f, 0.0f, 1.0f, carsix_elements[0]);
    if ( careight_visible )
      CarEightR_event.setValue(0.0f, 0.0f, 1.0f, careight_elements[0]);
    if ( cartwo_visible )
      CarTwoR_event.setValue(0.0f, 0.0f, 1.0f, cartwo_elements[0]);
    if ( carfour_visible )
      CarFourR_event.setValue(0.0f, 0.0f, 1.0f, carfour_elements[0]);
    if ( octopusclosed_visible )
      MainRotate_event.setValue(0.0f, 0.0f, 1.0f, octopusclosed_elements[0]);
  }
}

