/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import berkeley.cs.dmc.system.DynamicsVariable;

public class Pendulum2Theta implements DynamicsVariable {
    public Pendulum2Theta() {
    }

    public int numVariables() {
	return 1;
    }

    public int numFields() {
	return 1;
    }

    public float bufferStep() {
	return 0.01f;
    }

    public int bufferSize() {
	return 1;
    }

    public boolean initialCondition(double[] p) {
        p[0] = 0.0;
        return false;
    }

    public float newState(double last_time, double[] last_params,
                          double last_seen, double[] seen_params,
                          double new_time, double[] new_params) {
	new_params[0] = new_time * Pendulum2System.OMEGA_RUN;
        return 0.01f;
    }

    public void  evaluateFields(double t, double[] params, float[] fields) {
	fields[0] = (float)params[0];
    }
}


