/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
public class GenTable {
  public static final int SAMPLES = 5000;
  public static final double PERIOD = 12.1;

  public static void main( String args[] ) {
    RollerVariable var = new RollerVariable();
    int len = var.subsetLength();

    double in[] = new double[len];
    double out[] = new double[len];
    double t1 = 0.0, t2;

    var.initialCondition( in );

    for( int i=1 ; i<SAMPLES ; i++ ) {
      t2 = (double)i * PERIOD / (SAMPLES-1);

      System.out.print( t2+"\t" );
      var.evaluate( t1, in, t2, out );
      System.out.print( out[0]+"\t"+out[1]+"\t" );

      t1 = t2;
      in[0] = out[0];
      in[1] = out[1];

      var.doApprox( t2, out );
      System.out.print( out[0]+"\t"+out[1]+"\n" );
    }

    System.exit(0);
  }
}
