/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.field.*;
import vrml.node.*;
import berkeley.cs.dmc.system.DynamicsVariable;

public class TiltAWhirl extends Script {
  double time = 0.0;
  double last_time = 0.0;
  boolean initialized = false;
  double[] old_params = new double[7];
  double[] seen_params = new double[7];
  double[] new_params = new double[7];
  private TiltCarVariable bluevars = null;
  private MFFloat bluevars_buffer = null;
  private SFFloat bluevars_lastTime = null;
  private SFFloat bluevars_lastSeen = null;
  private float[] bluevars_elements = new float[1];
  private boolean bluevars_visible = true;
  private TiltThetaVars thetavars = null;
  private MFFloat thetavars_buffer = null;
  private SFFloat thetavars_lastTime = null;
  private SFFloat thetavars_lastSeen = null;
  private float[] thetavars_elements = new float[7];
  private boolean thetavars_visible = true;
  private TiltCarVariable yellowvars = null;
  private MFFloat yellowvars_buffer = null;
  private SFFloat yellowvars_lastTime = null;
  private SFFloat yellowvars_lastSeen = null;
  private float[] yellowvars_elements = new float[1];
  private boolean yellowvars_visible = true;
  private TiltCarVariable redvars = null;
  private MFFloat redvars_buffer = null;
  private SFFloat redvars_lastTime = null;
  private SFFloat redvars_lastSeen = null;
  private float[] redvars_elements = new float[1];
  private boolean redvars_visible = true;
  private TiltCarVarsClosed purpleclosed = null;
  private MFFloat purpleclosed_buffer = null;
  private SFFloat purpleclosed_lastTime = null;
  private SFFloat purpleclosed_lastSeen = null;
  private float[] purpleclosed_elements = new float[2];
  private TiltCarVariable whitevars = null;
  private MFFloat whitevars_buffer = null;
  private SFFloat whitevars_lastTime = null;
  private SFFloat whitevars_lastSeen = null;
  private float[] whitevars_elements = new float[1];
  private boolean whitevars_visible = true;
  private TiltCarVariable greenvars = null;
  private MFFloat greenvars_buffer = null;
  private SFFloat greenvars_lastTime = null;
  private SFFloat greenvars_lastSeen = null;
  private float[] greenvars_elements = new float[1];
  private boolean greenvars_visible = true;
  private TiltCarVarsClosed greenclosed = null;
  private MFFloat greenclosed_buffer = null;
  private SFFloat greenclosed_lastTime = null;
  private SFFloat greenclosed_lastSeen = null;
  private float[] greenclosed_elements = new float[2];
  private TiltCarVariable cyanvars = null;
  private MFFloat cyanvars_buffer = null;
  private SFFloat cyanvars_lastTime = null;
  private SFFloat cyanvars_lastSeen = null;
  private float[] cyanvars_elements = new float[1];
  private boolean cyanvars_visible = true;
  private TiltCarVarsClosed whiteclosed = null;
  private MFFloat whiteclosed_buffer = null;
  private SFFloat whiteclosed_lastTime = null;
  private SFFloat whiteclosed_lastSeen = null;
  private float[] whiteclosed_elements = new float[2];
  private TiltCarVarsClosed blueclosed = null;
  private MFFloat blueclosed_buffer = null;
  private SFFloat blueclosed_lastTime = null;
  private SFFloat blueclosed_lastSeen = null;
  private float[] blueclosed_elements = new float[2];
  private TiltCarVarsClosed yellowclosed = null;
  private MFFloat yellowclosed_buffer = null;
  private SFFloat yellowclosed_lastTime = null;
  private SFFloat yellowclosed_lastSeen = null;
  private float[] yellowclosed_elements = new float[2];
  private TiltCarVarsClosed redclosed = null;
  private MFFloat redclosed_buffer = null;
  private SFFloat redclosed_lastTime = null;
  private SFFloat redclosed_lastSeen = null;
  private float[] redclosed_elements = new float[2];
  private TiltCarVariable purplevars = null;
  private MFFloat purplevars_buffer = null;
  private SFFloat purplevars_lastTime = null;
  private SFFloat purplevars_lastSeen = null;
  private float[] purplevars_elements = new float[1];
  private boolean purplevars_visible = true;
  private TiltCarVarsClosed cyanclosed = null;
  private MFFloat cyanclosed_buffer = null;
  private SFFloat cyanclosed_lastTime = null;
  private SFFloat cyanclosed_lastSeen = null;
  private float[] cyanclosed_elements = new float[2];
  private SFRotation BlueRotate0_event = null;
  private SFRotation WhiteRotate5_event = null;
  private SFRotation WhiteRotate3_event = null;
  private SFRotation WhiteRotate2_event = null;
  private SFRotation WhiteRotate0_event = null;
  private SFRotation YellowRotate5_event = null;
  private SFRotation YellowRotate3_event = null;
  private SFRotation YellowRotate2_event = null;
  private SFRotation YellowRotate0_event = null;
  private SFRotation PurpleRotate5_event = null;
  private SFRotation PurpleRotate3_event = null;
  private SFRotation PurpleRotate2_event = null;
  private SFRotation CyanRotate5_event = null;
  private SFRotation PurpleRotate0_event = null;
  private SFRotation CyanRotate3_event = null;
  private SFRotation CyanRotate2_event = null;
  private SFRotation CyanRotate0_event = null;
  private SFRotation RedRotate5_event = null;
  private SFRotation RedRotate3_event = null;
  private SFRotation RedRotate2_event = null;
  private SFRotation RedRotate0_event = null;
  private SFRotation GreenRotate5_event = null;
  private SFRotation BlueRotate5_event = null;
  private SFRotation GreenRotate3_event = null;
  private SFRotation GreenRotate2_event = null;
  private SFRotation BlueRotate3_event = null;
  private SFRotation BlueRotate2_event = null;
  private SFRotation GreenRotate0_event = null;
  public void initialize() {
    if ( initialized ) return;
    bluevars = new TiltCarVariable();    bluevars_buffer = (MFFloat)getField("bluevars_buffer");
    bluevars_lastTime = (SFFloat)getField("bluevars_lastTime");
    bluevars_lastSeen = (SFFloat)getField("bluevars_lastSeen");
    thetavars = new TiltThetaVars();    thetavars_buffer = (MFFloat)getField("thetavars_buffer");
    thetavars_lastTime = (SFFloat)getField("thetavars_lastTime");
    thetavars_lastSeen = (SFFloat)getField("thetavars_lastSeen");
    yellowvars = new TiltCarVariable();    yellowvars_buffer = (MFFloat)getField("yellowvars_buffer");
    yellowvars_lastTime = (SFFloat)getField("yellowvars_lastTime");
    yellowvars_lastSeen = (SFFloat)getField("yellowvars_lastSeen");
    redvars = new TiltCarVariable();    redvars_buffer = (MFFloat)getField("redvars_buffer");
    redvars_lastTime = (SFFloat)getField("redvars_lastTime");
    redvars_lastSeen = (SFFloat)getField("redvars_lastSeen");
    purpleclosed = new TiltCarVarsClosed();    purpleclosed_buffer = (MFFloat)getField("purpleclosed_buffer");
    purpleclosed_lastTime = (SFFloat)getField("purpleclosed_lastTime");
    purpleclosed_lastSeen = (SFFloat)getField("purpleclosed_lastSeen");
    whitevars = new TiltCarVariable();    whitevars_buffer = (MFFloat)getField("whitevars_buffer");
    whitevars_lastTime = (SFFloat)getField("whitevars_lastTime");
    whitevars_lastSeen = (SFFloat)getField("whitevars_lastSeen");
    greenvars = new TiltCarVariable();    greenvars_buffer = (MFFloat)getField("greenvars_buffer");
    greenvars_lastTime = (SFFloat)getField("greenvars_lastTime");
    greenvars_lastSeen = (SFFloat)getField("greenvars_lastSeen");
    greenclosed = new TiltCarVarsClosed();    greenclosed_buffer = (MFFloat)getField("greenclosed_buffer");
    greenclosed_lastTime = (SFFloat)getField("greenclosed_lastTime");
    greenclosed_lastSeen = (SFFloat)getField("greenclosed_lastSeen");
    cyanvars = new TiltCarVariable();    cyanvars_buffer = (MFFloat)getField("cyanvars_buffer");
    cyanvars_lastTime = (SFFloat)getField("cyanvars_lastTime");
    cyanvars_lastSeen = (SFFloat)getField("cyanvars_lastSeen");
    whiteclosed = new TiltCarVarsClosed();    whiteclosed_buffer = (MFFloat)getField("whiteclosed_buffer");
    whiteclosed_lastTime = (SFFloat)getField("whiteclosed_lastTime");
    whiteclosed_lastSeen = (SFFloat)getField("whiteclosed_lastSeen");
    blueclosed = new TiltCarVarsClosed();    blueclosed_buffer = (MFFloat)getField("blueclosed_buffer");
    blueclosed_lastTime = (SFFloat)getField("blueclosed_lastTime");
    blueclosed_lastSeen = (SFFloat)getField("blueclosed_lastSeen");
    yellowclosed = new TiltCarVarsClosed();    yellowclosed_buffer = (MFFloat)getField("yellowclosed_buffer");
    yellowclosed_lastTime = (SFFloat)getField("yellowclosed_lastTime");
    yellowclosed_lastSeen = (SFFloat)getField("yellowclosed_lastSeen");
    redclosed = new TiltCarVarsClosed();    redclosed_buffer = (MFFloat)getField("redclosed_buffer");
    redclosed_lastTime = (SFFloat)getField("redclosed_lastTime");
    redclosed_lastSeen = (SFFloat)getField("redclosed_lastSeen");
    purplevars = new TiltCarVariable();    purplevars_buffer = (MFFloat)getField("purplevars_buffer");
    purplevars_lastTime = (SFFloat)getField("purplevars_lastTime");
    purplevars_lastSeen = (SFFloat)getField("purplevars_lastSeen");
    cyanclosed = new TiltCarVarsClosed();    cyanclosed_buffer = (MFFloat)getField("cyanclosed_buffer");
    cyanclosed_lastTime = (SFFloat)getField("cyanclosed_lastTime");
    cyanclosed_lastSeen = (SFFloat)getField("cyanclosed_lastSeen");
    BlueRotate0_event = (SFRotation)getEventOut("BlueRotate0");
    WhiteRotate5_event = (SFRotation)getEventOut("WhiteRotate5");
    WhiteRotate3_event = (SFRotation)getEventOut("WhiteRotate3");
    WhiteRotate2_event = (SFRotation)getEventOut("WhiteRotate2");
    WhiteRotate0_event = (SFRotation)getEventOut("WhiteRotate0");
    YellowRotate5_event = (SFRotation)getEventOut("YellowRotate5");
    YellowRotate3_event = (SFRotation)getEventOut("YellowRotate3");
    YellowRotate2_event = (SFRotation)getEventOut("YellowRotate2");
    YellowRotate0_event = (SFRotation)getEventOut("YellowRotate0");
    PurpleRotate5_event = (SFRotation)getEventOut("PurpleRotate5");
    PurpleRotate3_event = (SFRotation)getEventOut("PurpleRotate3");
    PurpleRotate2_event = (SFRotation)getEventOut("PurpleRotate2");
    CyanRotate5_event = (SFRotation)getEventOut("CyanRotate5");
    PurpleRotate0_event = (SFRotation)getEventOut("PurpleRotate0");
    CyanRotate3_event = (SFRotation)getEventOut("CyanRotate3");
    CyanRotate2_event = (SFRotation)getEventOut("CyanRotate2");
    CyanRotate0_event = (SFRotation)getEventOut("CyanRotate0");
    RedRotate5_event = (SFRotation)getEventOut("RedRotate5");
    RedRotate3_event = (SFRotation)getEventOut("RedRotate3");
    RedRotate2_event = (SFRotation)getEventOut("RedRotate2");
    RedRotate0_event = (SFRotation)getEventOut("RedRotate0");
    GreenRotate5_event = (SFRotation)getEventOut("GreenRotate5");
    BlueRotate5_event = (SFRotation)getEventOut("BlueRotate5");
    GreenRotate3_event = (SFRotation)getEventOut("GreenRotate3");
    GreenRotate2_event = (SFRotation)getEventOut("GreenRotate2");
    BlueRotate3_event = (SFRotation)getEventOut("BlueRotate3");
    BlueRotate2_event = (SFRotation)getEventOut("BlueRotate2");
    GreenRotate0_event = (SFRotation)getEventOut("GreenRotate0");
    initialized = true;
  }
  public void processEvent( Event e ) {
    String name = e.getName();
    if ( "currentTime".equals( name ) ) {
      time=((ConstSFFloat)e.getValue()).getValue();
    } else if ( "TiltBound".equals( name ) ) {
      thetavars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
      ((SFBool)getEventOut("visible")).setValue(thetavars_visible);
    } else if ( "RedBound".equals( name ) ) {
      redvars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "PurpleBound".equals( name ) ) {
      purplevars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "BlueBound".equals( name ) ) {
      bluevars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "CyanBound".equals( name ) ) {
      cyanvars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "WhiteBound".equals( name ) ) {
      whitevars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "GreenBound".equals( name ) ) {
      greenvars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "YellowBound".equals( name ) ) {
      yellowvars_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    }
  }
  private void timeStep(MFFloat buffer, SFFloat lastTime,
                        SFFloat lastSeen, double bufStep, double phase,
                        DynamicsVariable var, double time, float[] fields,
                        int num_p, int num_b) {
    time += phase;

    double last_time = (double)lastTime.getValue();
    double last_seen = (double)lastSeen.getValue();

    if ( num_b == 1 )
    {
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = (double)buffer.get1Value(i);
      var.newState(last_time, old_params,
                   last_time, old_params,
                   time, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(i, (float)new_params[i]);
      lastTime.setValue((float)time);
      var.evaluateFields(time, new_params, fields);
      return;
    }

    int    low_index = (int)Math.floor(time / bufStep);
    double low_time = low_index * bufStep;
    int    high_index = ( low_index + 1 ) % num_b;
    int    last_index = (int)Math.floor((last_time + 0.001) / bufStep) % num_b;
    int    seen_index = (int)Math.floor((last_seen + 0.001) / bufStep) % num_b;

    float work_done = 0.0f;

    int base = 0;

    low_index = low_index % num_b;

    base = last_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      old_params[i] = (double)buffer.get1Value(base + i);
    base = seen_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      seen_params[i] = (double)buffer.get1Value(base + i);

    if ( low_time >= last_time )
    {
      work_done = var.newState(last_time, old_params,
                               last_seen, seen_params,
                               time, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      base = low_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time = low_time;
      last_index = low_index;
    }
    if ( low_time + bufStep > last_time )
    {
      work_done += var.newState(low_time, old_params,
                                last_seen, seen_params,
                                low_time + bufStep, new_params);
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      base = high_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time = low_time + bufStep;
      last_index = high_index;
    }


    // Guaranteed to have low and high time buffer positions filled.
    int slots_used = last_index - low_index + 1;
    if ( slots_used < 1 )
      slots_used += num_b;
    base = 0;
    while (  work_done < 1.0f && slots_used < num_b )
    {
      work_done += var.newState(last_time, old_params,
                                last_seen, seen_params,
                                last_time + bufStep, new_params);
      last_index = ( last_index + 1 ) % num_b;
      base = last_index * num_p;
      for ( int i = 0 ; i < num_p ; i++ )
        old_params[i] = new_params[i];
      for ( int i = 0 ; i < num_p ; i++ )
        buffer.set1Value(base + i, (float)new_params[i]);
      last_time += bufStep;
      slots_used++;
    }

    lastTime.setValue((float)last_time);
    lastSeen.setValue((float)(low_time + bufStep));

    double fraction = ( time - low_time ) / bufStep;
    int base1 = high_index * num_p;
    base = low_index * num_p;
    for ( int i = 0 ; i < num_p ; i++ )
      new_params[i] = fraction * buffer.get1Value(base1 + i)
                    + ( 1.0 - fraction ) * buffer.get1Value(base + i);
    var.evaluateFields(time, new_params, fields);
  }
  public void eventsProcessed() {
    if ( ! initialized ) return;
    if ( time <= last_time )
        return;
    last_time = time;
    if ( bluevars_visible )
      timeStep(bluevars_buffer, bluevars_lastTime, bluevars_lastSeen, 0.1f, 2.63f, bluevars, last_time, bluevars_elements, 2, 31);
    if ( thetavars_visible )
      timeStep(thetavars_buffer, thetavars_lastTime, thetavars_lastSeen, 0.01f, 0.0f, thetavars, last_time, thetavars_elements, 7, 1);
    if ( yellowvars_visible )
      timeStep(yellowvars_buffer, yellowvars_lastTime, yellowvars_lastSeen, 0.1f, 1.758f, yellowvars, last_time, yellowvars_elements, 2, 31);
    if ( redvars_visible )
      timeStep(redvars_buffer, redvars_lastTime, redvars_lastSeen, 0.1f, 0.0f, redvars, last_time, redvars_elements, 2, 31);
    timeStep(purpleclosed_buffer, purpleclosed_lastTime, purpleclosed_lastSeen, 0.01f, 1.318f, purpleclosed, last_time, purpleclosed_elements, 2, 1);
    if ( whitevars_visible )
      timeStep(whitevars_buffer, whitevars_lastTime, whitevars_lastSeen, 0.1f, 2.198f, whitevars, last_time, whitevars_elements, 2, 31);
    if ( greenvars_visible )
      timeStep(greenvars_buffer, greenvars_lastTime, greenvars_lastSeen, 0.1f, 0.44f, greenvars, last_time, greenvars_elements, 2, 31);
    timeStep(greenclosed_buffer, greenclosed_lastTime, greenclosed_lastSeen, 0.01f, 0.44f, greenclosed, last_time, greenclosed_elements, 2, 1);
    if ( cyanvars_visible )
      timeStep(cyanvars_buffer, cyanvars_lastTime, cyanvars_lastSeen, 0.1f, 0.879f, cyanvars, last_time, cyanvars_elements, 2, 31);
    timeStep(whiteclosed_buffer, whiteclosed_lastTime, whiteclosed_lastSeen, 0.01f, 2.198f, whiteclosed, last_time, whiteclosed_elements, 2, 1);
    timeStep(blueclosed_buffer, blueclosed_lastTime, blueclosed_lastSeen, 0.01f, 2.63f, blueclosed, last_time, blueclosed_elements, 2, 1);
    timeStep(yellowclosed_buffer, yellowclosed_lastTime, yellowclosed_lastSeen, 0.01f, 1.758f, yellowclosed, last_time, yellowclosed_elements, 2, 1);
    timeStep(redclosed_buffer, redclosed_lastTime, redclosed_lastSeen, 0.01f, 0.0f, redclosed, last_time, redclosed_elements, 2, 1);
    if ( purplevars_visible )
      timeStep(purplevars_buffer, purplevars_lastTime, purplevars_lastSeen, 0.1f, 1.318f, purplevars, last_time, purplevars_elements, 2, 31);
    timeStep(cyanclosed_buffer, cyanclosed_lastTime, cyanclosed_lastSeen, 0.01f, 0.879f, cyanclosed, last_time, cyanclosed_elements, 2, 1);
    if ( thetavars_visible )
      BlueRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[2]);
    if ( whitevars_visible )
      WhiteRotate5_event.setValue(0.0f, 0.0f, 1.0f, whitevars_elements[0]);
    WhiteRotate3_event.setValue(1.0f, 0.0f, 0.0f, whiteclosed_elements[1]);
    WhiteRotate2_event.setValue(0.0f, -1.0f, 0.0f, whiteclosed_elements[0]);
    if ( thetavars_visible )
      WhiteRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[4]);
    if ( yellowvars_visible )
      YellowRotate5_event.setValue(0.0f, 0.0f, 1.0f, yellowvars_elements[0]);
    YellowRotate3_event.setValue(1.0f, 0.0f, 0.0f, yellowclosed_elements[1]);
    YellowRotate2_event.setValue(0.0f, -1.0f, 0.0f, yellowclosed_elements[0]);
    if ( thetavars_visible )
      YellowRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[6]);
    if ( purplevars_visible )
      PurpleRotate5_event.setValue(0.0f, 0.0f, 1.0f, purplevars_elements[0]);
    PurpleRotate3_event.setValue(1.0f, 0.0f, 0.0f, purpleclosed_elements[1]);
    PurpleRotate2_event.setValue(0.0f, -1.0f, 0.0f, purpleclosed_elements[0]);
    if ( cyanvars_visible )
      CyanRotate5_event.setValue(0.0f, 0.0f, 1.0f, cyanvars_elements[0]);
    if ( thetavars_visible )
      PurpleRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[1]);
    CyanRotate3_event.setValue(1.0f, 0.0f, 0.0f, cyanclosed_elements[1]);
    CyanRotate2_event.setValue(0.0f, -1.0f, 0.0f, cyanclosed_elements[0]);
    if ( thetavars_visible )
      CyanRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[3]);
    if ( redvars_visible )
      RedRotate5_event.setValue(0.0f, 0.0f, 1.0f, redvars_elements[0]);
    RedRotate3_event.setValue(1.0f, 0.0f, 0.0f, redclosed_elements[1]);
    RedRotate2_event.setValue(0.0f, -1.0f, 0.0f, redclosed_elements[0]);
    if ( thetavars_visible )
      RedRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[0]);
    if ( greenvars_visible )
      GreenRotate5_event.setValue(0.0f, 0.0f, 1.0f, greenvars_elements[0]);
    if ( bluevars_visible )
      BlueRotate5_event.setValue(0.0f, 0.0f, 1.0f, bluevars_elements[0]);
    GreenRotate3_event.setValue(1.0f, 0.0f, 0.0f, greenclosed_elements[1]);
    GreenRotate2_event.setValue(0.0f, -1.0f, 0.0f, greenclosed_elements[0]);
    BlueRotate3_event.setValue(1.0f, 0.0f, 0.0f, blueclosed_elements[1]);
    BlueRotate2_event.setValue(0.0f, -1.0f, 0.0f, blueclosed_elements[0]);
    if ( thetavars_visible )
      GreenRotate0_event.setValue(0.0f, 0.0f, 1.0f, thetavars_elements[5]);
  }
}

