/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class DistributorNoCull extends Script {
  double start_time = 0.0;
  double time = 0.0;
  double last_time = 0.0;
  double fraction = 0.0;
  boolean Octopus1_visible = false;
  boolean TiltAWhirl1_visible = false;
  boolean Roller1_visible = false;
  boolean DiveBomber1_visible = false;
  boolean Pendulum1_visible = false;
  boolean Pendulum2_visible = false;
  boolean SimplePendulum1_visible = false;
  public void processEvent( Event e ) {
    String name = e.getName();
    if ( "cycleTime".equals( name ) ) {
      time = ((ConstSFTime)e.getValue()).getValue();
      fraction = 0.0;
      if ( start_time == 0.0 )
        start_time = time;
    } else if ( "Octopus1Visible".equals(name) ) {
      Octopus1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "TiltAWhirl1Visible".equals(name) ) {
      TiltAWhirl1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "Roller1Visible".equals(name) ) {
      Roller1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "DiveBomber1Visible".equals(name) ) {
      DiveBomber1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "Pendulum1Visible".equals(name) ) {
      Pendulum1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "Pendulum2Visible".equals(name) ) {
      Pendulum2_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "SimplePendulum1Visible".equals(name) ) {
      SimplePendulum1_visible = (boolean)((ConstSFBool)e.getValue()).getValue();
    } else if ( "fraction_changed".equals( name ) )
      fraction = (double)((ConstSFFloat)e.getValue()).getValue();
  }
  public void eventsProcessed() {
    if ( time + fraction - start_time <= last_time )
        return;
    last_time = time + fraction - start_time;
    ((SFFloat)getEventOut("currentTime")).setValue((float)last_time);
    int inView = 0;
      inView++;
      ((SFFloat)getEventOut("Octopus1CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("TiltAWhirl1CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("Roller1CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("DiveBomber1CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("Pendulum1CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("Pendulum2CurrentTime")).setValue((float)last_time);
      inView++;
      ((SFFloat)getEventOut("SimplePendulum1CurrentTime")).setValue((float)last_time);
    ((SFInt32)getEventOut("numInView")).setValue(inView);
  }
}
