/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.node.*;
import vrml.field.*;

public class ModScript extends Script {
    float modulus;
    SFFloat value_changed;

    public void initialize() {
	modulus = ((SFFloat)getField("modulus")).getValue();
	value_changed = (SFFloat)getEventOut("value_changed");
    }

    public void processEvent(Event e) {
	float val_out = (float)Math.IEEEremainder(
		(double)((ConstSFFloat)e.getValue()).getValue(),
		(double)modulus)
	        / modulus;
	value_changed.setValue(val_out >= 0.0 ? val_out : 1.0f + val_out);
    }
}

