/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class TimingScript extends Script {
  int frame_count = 0;
  int num_in_view = 0;
  public void processEvent( Event e ) {
    String name = e.getName();
    float time = 0.0f;


    if ( "currentTime".equals( name ) ) {
      time = ((ConstSFFloat)e.getValue()).getValue();
      frame_count++;
      if ( ( frame_count % 20 ) == 0 && frame_count > 0 && time < 300.0f )
      {
        System.out.println("Frame Time = " + time / frame_count);
        System.out.println("Average in View: "
	                 + ( num_in_view / (double)frame_count) );
      }
      if ( time > 300.0f && time < 302.0f )
        System.out.println("DONE DONE DONE DONE DONE");
    } else if ( "numInView".equals( name ) ) {
      num_in_view += ((ConstSFInt32)e.getValue()).getValue();
    }

  }
}

