/*
 * DynamicsWrapper.java - Dynamics systems information for DMC compiler
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.compiler;

import java.io.PrintWriter;
import berkeley.cs.dmc.system.DynamicsSystem;
import berkeley.cs.dmc.probtree.ProbabilityTree;

class DynamicsWrapper {
    String              system_name = null;
    DynamicsSystem   	system = null;
    double[]	    	min_bounds = null;
    double[]	    	max_bounds = null;
    double		period = 0.0;
    double	    	sample_threshold = 0.0;
    double           	approx_threshold = 0.0;
    ProbabilityTree	equilibrium_distrib = null;
    NeuralNetSystem	approx_network = null;

    DynamicsWrapper(String name, DynamicsSystem sys)
    {
	system_name = name;
	system = sys;

	min_bounds = new double[system.subsetLength()];
	max_bounds = new double[system.subsetLength()];
    }
}

