package berkeley.cs.dmc.dmod;

import berkeley.cs.dmc.system.DynamicsVariable;

public class AnimateVar {
    private double[] last_p;
    private double[] seen_p;
    private double[] new_p;
    private float[] fields;
    private DynamicsVariable system;
    private float phase = 0.0f;
    private double last_time = 0.0;

    public AnimateVar(DynamicsVariable sys, float p) {
	system = sys;
	phase = p;

	int num_p = system.numVariables();
	int num_f = system.numFields();

	last_p = new double[num_p];
	seen_p = new double[num_p];
	new_p = new double[num_p];
	fields = new float[num_f];

	system.initialCondition(new_p);
    }

    public void update(double time) {
	time += phase;
	for ( int i = 0 ; i < new_p.length ; i++ )
	    last_p[i] = seen_p[i] = new_p[i];
	system.newState(last_time, last_p, last_time, seen_p, time, new_p);
	system.evaluateFields(time, new_p, fields);
	last_time = time;
    }

    public float getField(int i) {
	return fields[i];
    }
}

