package berkeley.cs.dmc.dmod;

import java.awt.*;

public class BaseDialog extends Dialog {
  public BaseDialog( Frame parent ) { super(parent); }
  public BaseDialog( Frame parent, boolean modal ) { super(parent, modal); }
  public BaseDialog( Frame parent, String title ) { super(parent, title); }
  public BaseDialog( Frame parent, String title, boolean modal ) { super(parent, title, modal); }

  /**
   * Centers the dialog over its parent when showing
   */
  public void setVisible( boolean state ) {
    if( state ) {
      Rectangle pb = getParent().getBounds();
      Rectangle b = getBounds();
      int x = pb.x + (pb.width - b.width) / 2;
      int y = pb.y + (pb.height - b.height) / 2;

      setLocation( x, y );
    }

    super.setVisible( state );
  }
}
