package berkeley.cs.dmc.dmod;

import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;

public class ChoiceDialog extends BaseDialog {
  public int choice;

  protected static Font defaultfont = null;
  public static void setDefaultFont( Font font ) {
    defaultfont = font;
  }
  public static Font getDefaultFont() {
    return defaultfont;
  }

  protected static final Insets insets = new Insets(4,4,4,4);

  public static int choose( Frame parent, String title, String text, String buttons ) {
    ChoiceDialog dlg = new ChoiceDialog( parent, title, text, buttons );
    dlg.setVisible( true );
    return dlg.choice;
  }

  public static void info( Frame parent, String title, String text ) {
    new ChoiceDialog( parent, title, text, "ok" ).setVisible( true );
  }

  private class ButtonAction implements ActionListener {
    int choiceno;
    ButtonAction( int c ) { choiceno = c; }
    public void actionPerformed( ActionEvent e ) {
      choice = choiceno;
      setVisible( false );
      dispose();
    }
  }

  public ChoiceDialog( Frame parent, String title, String text, String buttons ) {
    super( parent, title, true );

    if( defaultfont != null )
      setFont( defaultfont );

    StringTokenizer st = new StringTokenizer( buttons, "\n" );

    MultiLineLabel label = new MultiLineLabel( text );
    int numbuttons = st.countTokens();
    int i = 0;

    Panel buttonPanel = new Panel();
    buttonPanel.setLayout( new FlowLayout() );

    for( i=0 ; st.hasMoreTokens() ; i++ ) {
      Button b = new Button( st.nextToken() );
      buttonPanel.add( b );
      b.addActionListener( new ButtonAction( i ) );
    }

    GridBagLayout layout = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout( layout );
    c.gridx = 0;
    c.gridy = 1;
    c.fill = c.HORIZONTAL;
    add( buttonPanel, c );
    c.insets = insets;
    c.gridy = 0;
    add( label, c );

    pack();
    setResizable( false );
  }
}
