package berkeley.cs.dmc.dmod;

public class StringCharStream implements CharStream {
    String str;
    int off = 0;
    int len;

    public StringCharStream( String str ) {
	this.str = str;
	len = str.length();
    }

    public char readChar() throws java.io.EOFException {
	if( off >= len )
	    throw new java.io.EOFException();

	return str.charAt(off++);
    }

    int begin;

    public int getColumn() { return off; }
    public int getLine() { return 1; }
    public int getEndColumn() { return off; }
    public int getEndLine() { return 1; }
    public int getBeginColumn() { return begin; }
    public int getBeginLine() { return 1; }

    public void backup(int amount) { off -= amount; }

    public char BeginToken() throws java.io.IOException {
	char ch = readChar();
	begin = off-1;
	return ch;
    }
    public String GetImage() {
	return str.substring( begin, off );
    }

    public char[] GetSuffix(int len) {
	String t = GetImage();
	return t.substring(t.length() - len, t.length()).toCharArray();
    }

    public void Done() {}
}
