/*
 * DirectionalLight.java - Directional light source model
 * Copyright (C) 1998 Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.ji3d;

class DirectionalLight extends Light
{
    Vec3 center;
    Vec3 direction;

    public DirectionalLight( Vec3 color, Vec3 dir )
    {
        super( color );
        this.direction = dir;
    }

    protected float lightDir( Vec3 dir, Vec4 v )
    {
        dir.x = direction.x;
	dir.y = direction.y;
	dir.z = direction.z;
	return 0.0f;
    }

    protected float attenuate( float dist )
    {
        return 1.0f;
    }
}
