/*
 * Material.java - object material model
 * Copyright (C) 1998 Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.ji3d;

public final class Material extends Base
{
    public Vec3  ambient;
    public Vec3  diffuse;
    public Vec3  specular;
    public float shine;

    public Material( Vec3 ambient, Vec3 diffuse, Vec3 specular, float shine )
    {
        this.ambient  = new Vec3( ambient );
        this.diffuse  = new Vec3( diffuse );
        this.specular = new Vec3( specular );
        this.shine    = shine;
    }

	public Material( Material m ) {
		this.ambient = new Vec3( m.ambient );
		this.diffuse = new Vec3( m.diffuse );
		this.specular = new Vec3( m.specular );
		this.shine = m.shine;
	}
};
