/*
 * Options.java - Compile time specified options
 * Copyright (C) 1998 Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.ji3d;

public interface Options {
    public static final boolean debug = true;
    public static final boolean debugGC = false;
    public static final boolean debugParser = false;

    // Lighting options:
    public static final boolean ambientOn   = true;
    public static final boolean diffuseOn   = true;
    public static final boolean specularOn  = true;
    public static final boolean depthOn     = true;
    public static final boolean attenuateOn = false;
    public static final Vec3  depthque = new Vec3( 0.1f, 0.01f, 0.01f );
    public static final Vec3  background = new Vec3( 0.0f, 0.0f, 0.0f );

    // Display options:
    public static final boolean WIREFRAME = false;
    public static final boolean BACKFACE_CULL = true;
}

