/*
 * TranslateNode.java - Translation Node
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.model;

import java.io.PrintStream;

public class TranslateNode extends TreeNode {
    Object x = new Integer(0);
    Object y = new Integer(0);
    Object z = new Integer(0);

    public Object getX() { return x; }
    public Object getY() { return y; }
    public Object getZ() { return z; }

    public void setX( Object x ) { this.x = x; }
    public void setY( Object y ) { this.y = y; }
    public void setZ( Object z ) { this.z = z; }

    public String[] getFieldList() {
	return new String[] { "x", "y", "z" };
    }
    public void setField( String field, Object value ) {
	if( field.length() == 1 ) {
	    switch( field.charAt(0) ) {
	    case 'x': setX( value ); return;
	    case 'y': setY( value ); return;
	    case 'z': setZ( value ); return;
	    }
	}
	super.setField( field, value );
    }
    public Object getField( String field ) {
	if( field.length() == 1 ) {
	    switch( field.charAt(0) ) {
	    case 'x': return getX();
	    case 'y': return getY();
	    case 'z': return getZ();
	    }
	}
	return super.getField( field );
    }

    public String getType() { return "translate"; }
    public void printFields( PrintStream out, String indent ) {
	out.println( indent + "x " + formatValue(x) );
	out.println( indent + "y " + formatValue(y) );
	out.println( indent + "z " + formatValue(z) );
    }
}
