/*
 * VRMLModelNode.java - Tree node for VRML models
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.model;

import java.io.PrintStream;

public class VRMLModelNode extends ModelNode {
    Object url = "";
    public Object getURL() { return url; }
    public void setURL( Object url ) { this.url = url; }

    public berkeley.cs.dmc.vrml.parser.Scene scene = null;
    
    public String[] getFieldList() {
	return new String[] { "url" };
    }
    public void setField( String field, Object value ) {
	if( "url".equals(field) )
	    setURL( value );
	else
	    super.setField(field,value);
    }
    public Object getField( String field ) {
	if( "url".equals(field) )
	    return getURL();
	else
	    return super.getField(field);
    }
    public String getType() { return "vrml"; }
    public void printFields( PrintStream out, String indent ) {
	out.println( indent + "url " + formatValue(url) );
    }
}
