/*
 * VariableField.java - a field of a variable
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.model;

public class VariableField {
    VariableDefinition var;
    int index;
    float value = 0.0f;

    public VariableField(VariableDefinition var, int index)
    {
	this.var = var;
	this.index = index;
    }

    public VariableDefinition getVar() { return var; }
    public int getIndex() { return index; }
    public void setValue(float val) { value = val; }
    public float getValue() { return value; }

    public String toString() {
	return var.getName() + "[" + index + "]";
    }
}
