/* Generated By:JavaCC: Do not edit this line. DynamicsParser.java */
package berkeley.cs.dmc.model.parser;

import berkeley.cs.dmc.model.*;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Hashtable;

public class DynamicsParser implements DynamicsParserConstants {
  public void SemantError( Token token, String message ) {
    System.out.println("");
    System.out.println("Error at line " + token.beginLine +
                       ", column " + token.beginColumn +
                       ", at or near '" + token.image + "'" );
    System.out.println("   " + message );
    System.out.println("");
  }

  public static void main( String args[] ) throws ParseException, IOException {
    InputStream in = null;
    try {
      if( args.length == 0 )
        in = System.in;
      else
        in = new FileInputStream( args[0] );

      DynamicsParser parser = new DynamicsParser( in );
      System.out.println( "Parsing..." );
      TreeNode node = parser.parse().getTree();
      System.out.println( "done." );
      node.print();
    } finally {
      if( args.length != 0 && in != null )
        in.close();
    }
  }

//
// Parser definitions begin
//
  final public DynamicsModel parse() throws ParseException {
  Hashtable vars = new Hashtable();
  VariableDefinition var;
  TreeNode t;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      var = varDef();
                   vars.put( var.getName(), var );
    }
    t = node(vars);
    jj_consume_token(0);
      {if (true) return new DynamicsModel( vars, t );}
    throw new Error("Missing return statement in function");
  }

  final public int integer() throws ParseException {
  Token t;
    t = jj_consume_token(INTEGER);
        try {
            {if (true) return Integer.parseInt( t.image );}
        } catch( NumberFormatException e ) {
            SemantError( t, "invalid integer format" );
            {if (true) return 0;}
        }
    throw new Error("Missing return statement in function");
  }

  final public Number number() throws ParseException {
  Token s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      s = jj_consume_token(INTEGER);
    try {
      {if (true) return new Integer( s.image );}
    } catch( NumberFormatException e ) {
      SemantError( s, "invalid numeric format" );
      {if (true) return null;}
    }
      break;
    case REAL:
      s = jj_consume_token(REAL);
    try {
      {if (true) return new Double( s.image );}
    } catch( NumberFormatException e ) {
      SemantError( s, "invalid numeric format" );
      {if (true) return null;}
    }
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public VariableDefinition varDef() throws ParseException {
    Token name, type, arg;
    Number num;
    VariableDefinition var;
    name = jj_consume_token(IDENTIFIER);
    type = jj_consume_token(IDENTIFIER);
    num = number();
            var = new VariableDefinition( name.image, type.image );
            if( num != null ) var.setPhase( num.floatValue() );
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING:
      case INTEGER:
      case REAL:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER:
      case REAL:
        num = number();
                       if( num != null ) var.addArg( num );
        break;
      case STRING:
        arg = jj_consume_token(STRING);
                       var.addArg( arg.image );
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return var;}
    throw new Error("Missing return statement in function");
  }

  final public TreeNode node(Hashtable vars) throws ParseException {
  TreeNode node, sub;
  Token t, s;
  int idx;
  Object val;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRANSLATE:
      jj_consume_token(TRANSLATE);
                    node = new TranslateNode();
      break;
    case ROTATE:
      jj_consume_token(ROTATE);
                 node = new RotateNode();
      break;
    case GROUP:
      jj_consume_token(GROUP);
                node = new TreeNode();
      break;
    case VRML:
      jj_consume_token(VRML);
               node = new VRMLModelNode();
      break;
    case BOUND:
      jj_consume_token(BOUND);
                node = new BoundNode();
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      t = jj_consume_token(IDENTIFIER);
                     node.setName( t.image );
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRANSLATE:
      case ROTATE:
      case VRML:
      case GROUP:
      case BOUND:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        t = jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          s = jj_consume_token(IDENTIFIER);
                            idx=0;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            jj_consume_token(LBRACKET);
            idx = integer();
            jj_consume_token(RBRACKET);
            break;
          default:
            jj_la1[7] = jj_gen;
            ;
          }
            val = vars.get(s.image);
            if( val == null )
              SemantError( s, s.image + " undefined" );
            else
              val = new VariableField( (VariableDefinition)val, idx );
          break;
        case INTEGER:
        case REAL:
          val = number();
          break;
        case STRING:
          s = jj_consume_token(STRING);
                         val = s.image;
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
          if( val != null ) {
            try {
              node.setField( t.image, val );
            } catch( IllegalArgumentException e ) {
              SemantError( t, e.getMessage() );
            }
          }
        break;
      case TRANSLATE:
      case ROTATE:
      case VRML:
      case GROUP:
      case BOUND:
        sub = node(vars);
                         node.addChild( sub );
        break;
      default:
        jj_la1[9] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(RBRACE);
      {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  public DynamicsParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[10];
  final private int[] jj_la1_0 = {0x20000000,0x2200000,0x2200800,0x2200800,0x1f0000,0x20000000,0x201f0000,0x0,0x22200800,0x201f0000,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,};

  public DynamicsParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new DynamicsParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
  }

  public DynamicsParser(DynamicsParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
  }

  public void ReInit(DynamicsParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[41];
    for (int i = 0; i < 41; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 10; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 41; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
