/*
 * IdTable.java - Table for identifiers
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.model.parser;

import java.util.Hashtable;

public class IdTable {
    IdTable parent;
    Hashtable table = new Hashtable();

    protected IdTable( IdTable parent ) {
	this.parent = parent;
    }
    public IdTable() {
	this(null);
    }

    public void initTable() { table = new Hashtable(); }

    public IdTable push() { return new IdTable(this); }
    public IdTable pop() { return parent; }

    public void put( Identifier id ) { table.put( id, id ); }
    public boolean contains( Identifier id ) {
	return table.containsKey(id) ? true :
	    (parent == null ? false : parent.contains(id));
    }
}
