/*
 * Identifier.java - an identifier
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.model.parser;

public class Identifier {

    String name;
    int hashcode;

    public String getName() { return name; }
    public int hashCode() { return hashcode; }
    public String toString() { return name; }
    public boolean equals( Object id ) {
	if( id instanceof Identifier )
	    return name.equals( ((Identifier)id).name );
	else
	    return false;
    }

    public Identifier( String str ) {
	if( str == null )
	    throw new NullPointerException( "Identifiers may not be null" );

	name = str;
	hashcode = str.hashCode();
    }
}
