/*
 * BoundMaxFunc.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.periodic;

import berkeley.cs.dmc.system.DynamicsSystem;
import berkeley.cs.dmc.numericalMethods.MinimizeFunction;

class BoundMaxFunc implements MinimizeFunction {
    DynamicsSystem   system = null;
    int              dimension = 0;
    int              num_vars = 0;
    double[]         p = null;

    BoundMaxFunc(DynamicsSystem sys, int v, int d) {
	system = sys;
	dimension = d;
	num_vars = v;
	p = new double[num_vars];
    }

    public double evaluate(double x, Object[] data) {
	int      index = ((Integer)data[0]).intValue();
	double   t = ((Double)data[1]).doubleValue();
	double[] o = (double[])data[2];
	double   res = Double.MIN_VALUE;

	system.evaluate(t, o, x, p);
	for ( int i = index ; i < num_vars ; i += dimension )
	    if ( p[i] > res )
		res = p[i];

	return -res;
    }
}

