/*
 * FieldData.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.tovrml;

import berkeley.cs.dmc.model.TreeNode;
import java.util.Vector;

class FieldData {
    private String    name = null;
    private int       type = 0;
    private TreeNode  node = null;
    private Vector    variables = new Vector(5, 5);

    FieldData(String n, int t, TreeNode p) {
	name = n;
	type = t;
	node = p;
    }

    int getType() {
	return type;
    }

    TreeNode getNode() {
	return node;
    }

    void addVariable(VariableData v) {
	variables.addElement(v);
    }

    Vector getVariables() {
	return variables;
    }
}


