/*
 * VariableData.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.tovrml;

import java.util.Vector;

class VariableData {
    private String    name = null;
    private ClassData type = null;
    private float     phase = 0.0f;
    private boolean   bound = false;

    VariableData(String n, ClassData c, float p) {
	name = n;
	type = c;
	phase = p;
    }

    String getName() {
	return name;
    }

    void setBound(boolean b) {
	bound = b;
    }

    boolean getBound() {
	return bound;
    }

    ClassData getType() {
	return type;
    }

    float getPhase() {
	return phase;
    }
}


