/*
 * Event.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml;

public class Event implements Cloneable {
    private String name;
    private double time;
    private ConstField value;

    public Event( String name, double time, ConstField value ) {
	this.name = name;
	this.time = time;
	this.value = value;
    }

    public String getName() { return name; }
    public double getTimeStamp() { return time; }
    public ConstField getValue() { return value; }

    public Object clone() {
	try {
	    return super.clone();
	} catch( CloneNotSupportedException e ) {
	    throw new InternalError( e.toString() );
	}
    }

    public String toString() {
	return getClass().getName()+
	    "[ "+name+"="+name+", time="+time+", value="+value+" ]";
    }
}
