/*
 * ConstMFColor.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstMField;

public class ConstMFColor extends ConstMField {
    private float array[];

    public ConstMFColor(float colors[][]) {
	int size = colors.length;
	float c[] = new float[size*3];
	int i,j;

	for( i=j=0 ; i<size ; i++ ) {
	    c[j++] = colors[i][0];
	    c[j++] = colors[i][1];
	    c[j++] = colors[i][2];
	}
	
	this.array = c;
    }

    public ConstMFColor(float colors[]) {
	this( colors.length / 3, colors );
    }

    public ConstMFColor(int size, float colors[]) {
	System.arraycopy( colors, 0, this.array = new float[size*3], 0, size*3 );
    }

    public int getSize() { return array.length / 3; }

    public void getValue(float colors[][]) {
	int i,j;
	float c[] = this.array;
	int numc = Math.min( colors.length, getSize() );

	for( i=j=0; i<numc ; i++ ) {
	    colors[i][0] = c[j++];
	    colors[i][1] = c[j++];
	    colors[i][2] = c[j++];
	}
    }

    public void getValue(float colors[]) {
	System.arraycopy( this.array, 0, colors, 0,
			  Math.min( colors.length, array.length ) );
    }

    public void get1Value(int index, float colors[]) {
	int i = index*3;
	float c[] = this.array;

	colors[0] = c[i];
	colors[1] = c[i+1];
	colors[2] = c[i+2];
    }
	
    public void get1Value(int index, SFColor color) {
	int i = index*3;
	float c[] = this.array;
	color.setValue(c[i], c[i+1], c[i+2]);
    }

    public String toString() {
	int count = array.length;

        if( count == 0 )
            return "[]";
        else {
            StringBuffer str = new StringBuffer();
            str.append( "[ " );
            for( int i=0 ; i<count ; i++ )
                str.append( array[i] ).append( " " );
            str.append( "]" );
            return new String( str );
        }
    }
}
