/*
 * ConstMFNode.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstMField;
import berkeley.cs.dmc.vrml.node.BaseNode;

public class ConstMFNode extends ConstMField {
    private BaseNode array[];

    public ConstMFNode(int size, BaseNode values[] ) {
	System.arraycopy(values,0, array=new BaseNode[size],0, size );
    }
    public ConstMFNode(BaseNode values[]) {
	this( values.length, values );
    }

    public int getSize() { return array.length; }
    public void getValue(BaseNode values[]) {
	System.arraycopy(array,0, values,0, Math.min(array.length, values.length));
    }
    public BaseNode get1Value(int index) { return array[index]; }
    public String toString() {
	int count = array.length;

        if( count == 0 )
            return "[]";
        else {
            StringBuffer str = new StringBuffer();
            str.append( "[ " );
            for( int i=0 ; i<count ; i++ )
                str.append( array[i] ).append( " " );
            str.append( "]" );
            return new String( str );
        }
    }
}
