/*
 * ConstMFRotation.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstMField;

public class ConstMFRotation extends ConstMField {
    private float array[];

    public ConstMFRotation(float rotations[][]) {
	int size = rotations.length;
	float c[] = new float[size*4];
	int i,j;

	for( i=j=0 ; i<size ; i++ ) {
	    c[j++] = rotations[i][0];
	    c[j++] = rotations[i][1];
	    c[j++] = rotations[i][2];
	    c[j++] = rotations[i][3];
	}
	
	this.array = c;
    }

    public ConstMFRotation(float rotations[]) {
	this( rotations.length / 4, rotations );
    }

    public ConstMFRotation(int size, float rotations[]) {
	System.arraycopy( rotations, 0, this.array = new float[size*4], 0, size*4 );
    }

    public int getSize() { return array.length / 4; }

    public void getValue(float rotations[][]) {
	int i,j;
	float v[] = array;
	int numc = Math.min( rotations.length, getSize() );

	for( i=j=0; i<numc ; i++ ) {
	    rotations[i][0] = v[j++];
	    rotations[i][1] = v[j++];
	    rotations[i][2] = v[j++];
	    rotations[i][3] = v[j++];
	}
    }

    public void getValue(float rotations[]) {
	System.arraycopy( array, 0, rotations, 0,
			  Math.min( rotations.length, array.length ) );
    }

    public void get1Value(int index, float rotations[]) {
	int i = index*4;
	float v[] = this.array;

	rotations[0] = v[i];
	rotations[1] = v[i+1];
	rotations[2] = v[i+2];
	rotations[3] = v[i+3];
    }
	
    public void get1Value(int index, SFRotation rotation) {
	int i = index*4;
	float v[] = this.array;
	rotation.setValue(v[i], v[i+1], v[i+2], v[i+3]);
    }

    public String toString() {
	int count = array.length;

        if( count == 0 )
            return "[]";
        else {
            StringBuffer str = new StringBuffer();
            str.append( "[ " );
            for( int i=0 ; i<count ; i++ )
                str.append( array[i] ).append( " " );
            str.append( "]" );
            return new String( str );
        }
    }
}
