/*
 * ConstMFVec2f.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstMField;

public class ConstMFVec2f extends ConstMField {
    private float array[];

    public ConstMFVec2f(float vec2s[][]) {
	int size = vec2s.length;
	float c[] = new float[size*2];
	int i,j;

	for( i=j=0 ; i<size ; i++ ) {
	    c[j++] = vec2s[i][0];
	    c[j++] = vec2s[i][1];
	}
	
	this.array = c;
    }

    public ConstMFVec2f(float vec2s[]) {
	this( vec2s.length / 2, vec2s );
    }

    public ConstMFVec2f(int size, float vec2s[]) {
	System.arraycopy( vec2s, 0, this.array = new float[size*2], 0, size*2 );
    }

    public int getSize() { return array.length / 2; }

    public void getValue(float vec2s[][]) {
	int i,j;
	float v[] = array;
	int numc = Math.min( vec2s.length, getSize() );

	for( i=j=0; i<numc ; i++ ) {
	    vec2s[i][0] = v[j++];
	    vec2s[i][1] = v[j++];
	}
    }

    public void getValue(float vec2s[]) {
	System.arraycopy( array, 0, vec2s, 0,
			  Math.min( vec2s.length, array.length ) );
    }

    public void get1Value(int index, float vec2s[]) {
	int i = index*2;
	float v[] = this.array;

	vec2s[0] = v[i];
	vec2s[1] = v[i+1];
    }
	
    public void get1Value(int index, SFVec2f vec2) {
	int i = index*2;
	float v[] = array;
	vec2.setValue(v[i], v[i+1]);
    }

    public String toString() {
	int count = array.length;

        if( count == 0 )
            return "[]";
        else {
            StringBuffer str = new StringBuffer();
            str.append( "[ " );
            for( int i=0 ; i<count ; i++ )
                str.append( array[i] ).append( " " );
            str.append( "]" );
            return new String( str );
        }
    }
}
