/*
 * ConstSFImage.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstField;

public class ConstSFImage extends ConstField {
    private int w,h,c;
    private byte p[];

    public ConstSFImage( int width, int height, int components, byte pixels[] ) {
	w = width;
	h = height;
	c = components;
	p = new byte[pixels.length];
	System.arraycopy( pixels, 0, p, 0, pixels.length );
    }

    public int getWidth() { return w; }
    public int getHeight() { return h; }
    public int getComponents() { return c; }
    public void getPixels(byte pixels[]) {
	System.arraycopy( p, 0, pixels, 0, Math.min( p.length, pixels.length ) );
    }

    public String toString() {
	StringBuffer str = new StringBuffer( w+" "+h+" "+c );
	int i;
	for( i=0 ; i<p.length ; i++ )
	    str.append(" ").append( p[i] );

	return new String(str);
    }
}
