/*
 * ConstSFRotation.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstField;

public class ConstSFRotation extends ConstField {
    private float x,y,z,a;

    public ConstSFRotation(float axisX, float axisY, float axisZ, float angle) {
	x = axisX;
	y = axisY;
	z = axisZ;
	a = angle;
    }

    public void getValue(float rotations[]) {
	rotations[0] = x;
	rotations[1] = y;
	rotations[2] = z;
	rotations[3] = a;
    }

    public String toString() {
	return x+","+y+","+z+","+a;
    }
}
