/*
 * ConstSFVec3f
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

import berkeley.cs.dmc.vrml.ConstField;

public class ConstSFVec3f extends ConstField {
    private float x,y,z;

    public ConstSFVec3f(float x, float y, float z) {
	this.x = x;
	this.y = y;
	this.z = z;
    }
    public void getValue(float vec3s[]) {
	vec3s[0] = x;
	vec3s[1] = y;
	vec3s[2] = z;
    }
    public float getX() { return x; }
    public float getY() { return y; }
    public float getZ() { return z; }

    public String toString() { return x+","+y+","+z; }
}
