/*
 * SFColor.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

public class SFColor extends berkeley.cs.dmc.vrml.Field
{
    float r;
    float g;
    float b;

    public SFColor(float red, float green, float blue) { r=red; g=green; b=blue; }
    public synchronized void getValue(float color[]) { color[0]=r; color[1]=g; color[2]=b; }
    public float getRed() { return r; }
    public float getGreen() { return g; }
    public float getBlue() { return b; }
    public synchronized void setValue(float color[]) { r=color[0]; g=color[1]; b=color[2]; }
    public synchronized void setValue(float red, float green, float blue) { r=red; g=green; b=blue; }
    public synchronized void setValue(ConstSFColor color) {
	r = color.getRed();
	g = color.getGreen();
	b = color.getBlue();
    }
    public synchronized void setValue(SFColor color) { r=color.r; g=color.g; b=color.b; }

    public synchronized String toString() {
        return r + " " + g + " " + b;
    }
}
