/*
 * SFRotation.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

public class SFRotation extends berkeley.cs.dmc.vrml.Field {

    float x, y, z, angle;

    public SFRotation() { x=y=angle=0; z=1; }
    public SFRotation( float axisX, float axisY, float axisZ, float angle ) {
        x = axisX;
        y = axisY;
        z = axisZ;
        this.angle = angle;
    }

    public synchronized void getValue( float rotation[] ) {
        rotation[0] = x;
        rotation[1] = y;
        rotation[2] = z;
        rotation[3] = angle;
    }

    public synchronized void setValue( float rotation[] ) {
        x = rotation[0];
        y = rotation[1];
        z = rotation[2];
        angle = rotation[3];
    }

    public synchronized void setValue( float axisX, float axisY, float axisZ, float angle ) {
        x = axisX;
        y = axisY;
        z = axisZ;
        this.angle = angle;
    }

    public void setValue( ConstSFRotation rotation ) {
	float r[] = new float[4];
	rotation.getValue(r);
	setValue(r);
    }

    public synchronized void setValue( SFRotation rotation ) {
        x = rotation.x;
        y = rotation.y;
        z = rotation.z;
        angle = rotation.angle;
    }

    public synchronized String toString() {
        return x + " " + y + " " + z + " " + angle;
    }
}
