/*
 * SFVec3f.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.field;

public class SFVec3f extends berkeley.cs.dmc.vrml.Field
{
    float x,y,z;

    public SFVec3f() { x=y=z= 0; }
    public SFVec3f(float x, float y, float z) { this.x=x; this.y=y; this.z=z; }
    public void getValue(float vec[]) { x = vec[0]; y = vec[1]; z = vec[2]; }
    public float getX() { return x; }
    public float getY() { return y; }
    public float getZ() { return z; }
    public synchronized void setValue(float vec[]) { x = vec[0]; y = vec[1]; z = vec[2]; }
    public synchronized void setValue(float x, float y, float z) { this.x=x; this.y=y; this.z=z; }
    public synchronized void setValue(ConstSFVec3f vec) {
	x = vec.getX();
	y = vec.getY();
	z = vec.getZ();
    }
    public synchronized void setValue(SFVec3f vec) { x=vec.x; y=vec.y; z=vec.z; }

    public String toString() {
        return x + " " + y + " " + z;
    }
}
