/*
 * USENode.java
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser;

import berkeley.cs.dmc.vrml.node.BaseNode;
import berkeley.cs.dmc.vrml.Field;
import berkeley.cs.dmc.vrml.RenderState;

public class USENode extends ParserNode {
    public String name;
    public ParserNode node;

    public int getFieldType( String field ) { return -1; }
    public void setField( String field, Field val ) {}
    public String getType() { return node.getType(); } // XXX: this needs to be defined!
    public USENode( String name, ParserNode node ) {
	this.name = name;
	this.node = node;
    }
    public void dump( String indent, java.io.PrintStream out ) {
	out.println(indent+"USE "+name);
    }
    public void build() {} // Build in DEF statement
    public void render( RenderState state ) {
	node.render( state );
    }
}
