/* Generated By:JavaCC: Do not edit this line. VRMLParser.java */
package berkeley.cs.dmc.vrml.parser;

// import berkeley.cs.dmc.vrml.node.BaseNode;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import java.util.Vector;

import berkeley.cs.dmc.vrml.Field;
import berkeley.cs.dmc.vrml.field.*;

public class VRMLParser implements VRMLParserConstants {
    Scene scene = null;

    URL url = null;
    File file = null;

    public static void main(String args[]) {
        VRMLParser t; // = new VRMLParser( new java.io.DataInputStream(System.in));
        try {
            t = VRMLParser.parse( new File(args[0]) );
            // t.file();
            t.dump(System.out);
        } catch( Exception e ) {
            // System.out.println( e.getMessage() );
            e.printStackTrace();
        }
    }

    Proto parseExternProto( Token t ) {
        String s = ((StringToken)t).value;
        String name;
        int i = s.indexOf( '#' );

        if( i < 0 )
            name = null;
        else {
            name = s.substring( i+1 );
            s = s.substring( 0, i );
        }

        VRMLParser parser;

        try {
            if( url != null ) {
                parser = parse( new URL( url, s ) );
            } else if( t.image.startsWith( "http://" ) ) {
                parser = parse( new URL( s ) );
            } else if( file != null ) {
                parser = parse( new File( file.getParent(), s ) );
            } else {
                File f = new File(s);
                if( f.exists() ) {
                    parser = parse(f);
                } else {
                    parser = parse( new URL(s) );
                }
            }

            Proto proto = parser.getProto( name );

            if( proto == null )
                warning( t, name == null ?
                         "No PROTO in "+s :
                         "No "+name+" PROTO in "+s );

            return proto;

        } catch( MalformedURLException e ) {
            warning( t, "Malformed URL: "+s );
        } catch( FileNotFoundException e ) {
            warning( t, "File not found: "+s );
        } catch( IOException e ) {
            warning( t, "IO Error reading "+s+": "+e.getMessage() );
        } catch( ParseException e ) {
            warning( t, "Parse error reading "+s+": "+e.getMessage() );
        } catch( Exception e ) {
            warning( t, "Exception processing "+s );
            System.out.println( "Stack trace follows:" );
            e.printStackTrace();
        }

        return null;
    }

    public static VRMLParser parse( File file )
         throws IOException, ParseException
    {
        InputStream in = new FileInputStream( file );
        try {
            System.out.println( "Processing: "+file );
            VRMLParser parser = new VRMLParser( in );
            parser.file = file;
            parser.file();
            return parser;
        } finally {
            in.close();
        }
    }

    public static VRMLParser parse( URL url )
         throws IOException, ParseException
    {
        InputStream in = url.openStream();
        try {
            VRMLParser parser = new VRMLParser( in );
            parser.url = url;
            parser.file();
            return parser;
        } finally {
            in.close();
        }
    }

    public void dump( java.io.PrintStream out ) {
        out.println( "DUMPING..." );
        if( scene != null )
            scene.dump( "", out );
        out.println( "END OF DUMP" );
    }

    public void warning( Token t, String text ) {
        String where = file != null ? file.toString() : (url != null ? url.toString() : "<STDIN>");
        System.out.println( where+": Warning at line "+t.beginLine+
                            ", column "+t.beginColumn+": "+text );
    }

    public Scene getScene() {
        return scene;
    }

    public Proto getProto( String name ) {
        return scene == null ? null :
            (name == null ? scene.getFirstProto() : scene.getProto(name));
    }

    public Field parseFieldType( String type ) throws ParseException {
        int len = type.length();
        if( len >= 6 ) {
            if( type.charAt(1) == 'F' ) {
                boolean sf = type.charAt(0) == 'S';

                switch( type.charAt(2) ) {
                case 'B': // SFBool
                    return sfbool();
                case 'C': // MFColor SFColor
                    return sf ? (Field)sfcolor() : (Field)mfcolor();
                case 'F': // MFFloat SFFloat
                    return sf ? (Field)sffloat() : (Field)mffloat();
                case 'I': // MFInt32 SFInt32 SFImage
                    if( sf ) {
                        if( type.charAt(5) == 'g' )     return sfimage();
                        else return sfint32();
                    } else return mfint32();
                case 'N': // MFNode SFNode
                    return sf ? (Field)sfnode() : (Field)mfnode();
                case 'R': // MFRotation SFRotation
                    return sf ? (Field)sfrotation() : (Field)mfrotation();
                case 'S': // MFString SFString
                    return sf ? (Field)sfstring() : (Field)mfstring();
                case 'T': // MFTime SFTime
                    return sf ? (Field)sftime() : (Field)mftime();
                case 'V': // MFVec2f MFVec3f SFVec2f SFVec3f
                    if( type.charAt(5) == '2' )
                        return sf ? (Field)sfvec2f() : (Field)mfvec2f();
                    else
                        return sf ? (Field)sfvec3f() : (Field)mfvec3f();
                }
            }
        }
        throw new InternalError("Type = "+type);
    }

/*
 * VRML 2.0 Grammer definitions follow
 */
  final public void file() throws ParseException {
        Token header = getToken(1);
        while( header.specialToken != null )
            header = header.specialToken;

        if( !header.image.startsWith( "#VRML V2.0 utf8" ) )
            warning( header, "Bad or missing VRML Header" );

        scene = new Scene();
    scene();
    jj_consume_token(0);
  }

  final public void scene() throws ParseException {
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROTO:
      case EXTERNPROTO:
      case DEF:
      case USE:
      case ROUTE:
      case SCRIPT:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      statement();
    }
  }

  final public void statement() throws ParseException {
    Route r;
    Proto p;
    ParserNode n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEF:
    case USE:
    case SCRIPT:
    case IDENTIFIER:
      n = nodeStatement();
                           scene.addNode(n);
      break;
    case PROTO:
    case EXTERNPROTO:
      p = protoStatement();
                           scene.addProto(p);
      break;
    case ROUTE:
      r = routeStatement();
                           scene.addRoute(r);
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public ParserNode nodeStatement() throws ParseException {
                               Token t; ParserNode n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SCRIPT:
    case IDENTIFIER:
      n = node();
      break;
    case DEF:
      jj_consume_token(DEF);
      t = jj_consume_token(IDENTIFIER);
      n = node();
          if( n != null ) {
              if( !scene.def(t, n) )
                  warning( t, "'"+t.image+"' already defined" );
          }
      break;
    case USE:
      jj_consume_token(USE);
      t = jj_consume_token(IDENTIFIER);
          if( (n = scene.use(t)) == null )
              warning( t, "'"+t.image+"' not defined" );
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return n;}
    throw new Error("Missing return statement in function");
  }

  final public Proto protoStatement() throws ParseException {
    Proto p;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROTO:
      p = proto();
      break;
    case EXTERNPROTO:
      p = externproto();
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return p;}
    throw new Error("Missing return statement in function");
  }

  final public Proto proto() throws ParseException {
    Token t;
    Proto p;
    jj_consume_token(PROTO);
    t = jj_consume_token(IDENTIFIER);
          p = new Proto(t.image);
    jj_consume_token(LBRACKET);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EVENTIN:
      case EVENTOUT:
      case FIELD:
      case EXPOSEDFIELD:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_2;
      }
      interfaceDeclaration(p);
    }
    jj_consume_token(RBRACKET);
    jj_consume_token(LBRACE);
    protoBody(p);
    jj_consume_token(RBRACE);
          {if (true) return p;}
    throw new Error("Missing return statement in function");
  }

  final public void protoBody(Proto proto) throws ParseException {
    Scene parentScene = scene;
    scene = proto;
    scene();
        scene = parentScene;
  }

  final public void interfaceDeclaration(Proto p) throws ParseException {
    Token t,n;
    Field val;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EVENTIN:
      jj_consume_token(EVENTIN);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                               p.addEventIn(t,n);
      break;
    case EVENTOUT:
      jj_consume_token(EVENTOUT);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                                p.addEventOut(t,n);
      break;
    case FIELD:
      jj_consume_token(FIELD);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
      val = parseField(t);
                                                               p.addField(t,n,val);
      break;
    case EXPOSEDFIELD:
      jj_consume_token(EXPOSEDFIELD);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
      val = parseField(t);
                                                                      p.addExposedField(t,n,val);
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public Proto externproto() throws ParseException {
    Token t;
    ExternProto p;
    Vector urls;
    jj_consume_token(EXTERNPROTO);
    t = jj_consume_token(IDENTIFIER);
          p = new ExternProto(t.image);
    jj_consume_token(LBRACKET);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EVENTIN:
      case EVENTOUT:
      case FIELD:
      case EXPOSEDFIELD:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
      externInterfaceDeclaration(p);
    }
    jj_consume_token(RBRACKET);
    urls = urls();
            p.setUrl( urls );

            for( int i=0 ; i<urls.size() ; i++ ) {
                Proto proto = parseExternProto( (Token)urls.elementAt(i) );
                if( proto != null && proto.equals(p) ) // equals only checks interface
                    {if (true) return proto;}
            }

            warning( t, "Matching PROTO not found in URL list" );
            {if (true) return null;}
    throw new Error("Missing return statement in function");
  }

  final public Vector urls() throws ParseException {
                  Token t; Vector v = new Vector();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      t = jj_consume_token(STRING);
                   v.addElement(t);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRING:
          ;
          break;
        default:
          jj_la1[7] = jj_gen;
          break label_4;
        }
        t = jj_consume_token(STRING);
                        v.addElement(t);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

  final public void externInterfaceDeclaration(ExternProto p) throws ParseException {
    Token t,n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EVENTIN:
      jj_consume_token(EVENTIN);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                                p.addEventIn(t,n);
      break;
    case EVENTOUT:
      jj_consume_token(EVENTOUT);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                                p.addEventOut(t,n);
      break;
    case FIELD:
      jj_consume_token(FIELD);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                                p.addField(t,n);
      break;
    case EXPOSEDFIELD:
      jj_consume_token(EXPOSEDFIELD);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
                                                    p.addExposedField(t,n);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public Route routeStatement() throws ParseException {
                           Token a,b,c,d;
    jj_consume_token(ROUTE);
    a = jj_consume_token(IDENTIFIER);
    jj_consume_token(DOT);
    b = jj_consume_token(IDENTIFIER);
    jj_consume_token(TO);
    c = jj_consume_token(IDENTIFIER);
    jj_consume_token(DOT);
    d = jj_consume_token(IDENTIFIER);
      {if (true) return new Route( a.image, b.image, c.image, d.image );}
    throw new Error("Missing return statement in function");
  }

  final public ParserNode node() throws ParseException {
    Token name;
    ParserNode node = null;
    ScriptNode script = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      name = jj_consume_token(IDENTIFIER);
          Proto proto = scene.getProto(name.image);
          if( proto != null ) {
              node = new ProtoInstance(proto);
          } else {
              try {
                  Class nodeclass = Class.forName( "berkeley.cs.dmc.vrml.parser.node."+name );
                  node = (ParserNode)nodeclass.newInstance();
              } catch( ClassNotFoundException e ) { // Class.forName()
                  warning( name, "Unknown node type '"+name.image+"'" );
              } catch( Throwable e ) {
                  // catch( InstantiationException e ) {} // newInstance()
                  // catch( IllegalAccessException e ) {} // newInstance()

                  // This should not happen.  It implies that a class
                  // in the package berkeley.cs.dmc.vrml.parser.node threw an exception when it
                  // was being instanced.  Since I wrote all of these class, and none of
                  // them are capable of throwing an exception (except possibly OutOfMemory)
                  // something is definitely wrong.

                  System.out.println( "INTERNAL ERROR (name = "+name+")" );
                  e.printStackTrace();
                  System.exit(1);
              }
          }
      jj_consume_token(LBRACE);
      nodeBody(node);
      jj_consume_token(RBRACE);
        {if (true) return node;}
      break;
    case SCRIPT:
      jj_consume_token(SCRIPT);
      jj_consume_token(LBRACE);
        script = new ScriptNode();
      scriptBody(script);
      jj_consume_token(RBRACE);
        {if (true) return script;}
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void nodeBody(ParserNode node) throws ParseException {
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROTO:
      case EXTERNPROTO:
      case ROUTE:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_5;
      }
      nodeBodyElement(node);
    }
  }

  final public void scriptBody(ScriptNode script) throws ParseException {
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROTO:
      case EXTERNPROTO:
      case EVENTIN:
      case EVENTOUT:
      case FIELD:
      case ROUTE:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_6;
      }
      scriptBodyElement(script);
    }
  }

  final public void scriptBodyElement(ScriptNode script) throws ParseException {
    Token t, n, is = null;
    Field i;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROTO:
    case EXTERNPROTO:
    case ROUTE:
    case IDENTIFIER:
      nodeBodyElement(script);
      break;
    case EVENTIN:
      jj_consume_token(EVENTIN);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IS:
        jj_consume_token(IS);
        is = jj_consume_token(IDENTIFIER);
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
        script.addEventIn(t,n,is);
      break;
    case EVENTOUT:
      jj_consume_token(EVENTOUT);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IS:
        jj_consume_token(IS);
        is = jj_consume_token(IDENTIFIER);
        break;
      default:
        jj_la1[14] = jj_gen;
        ;
      }
        script.addEventOut(t,n,is);
      break;
    case FIELD:
      jj_consume_token(FIELD);
      t = fieldType();
      n = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IS:
        jj_consume_token(IS);
        is = jj_consume_token(IDENTIFIER);
            script.addField(t,n,is);
        break;
      default:
        jj_la1[15] = jj_gen;
        i = parseField(t);
            script.addField(t,n,i);
      }
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  Field parseField(Token type) throws ParseException {
    return parseFieldKind( type.kind );
  }

  Field parseFieldKind(int kind) throws ParseException {
    switch( kind ) {
    case MFCOLOR: return mfcolor();
    case MFFLOAT: return mffloat();
    case MFINT32: return mfint32();
    case MFNODE: return mfnode();
    case MFROTATION: return mfrotation();
    case MFSTRING: return mfstring();
    case MFVEC2F: return mfvec2f();
    case MFVEC3F: return mfvec3f();
    case SFBOOL: return sfbool();
    case SFCOLOR: return sfcolor();
    case SFFLOAT: return sffloat();
    case SFIMAGE: return sfimage();
    case SFINT32: return sfint32();
    case SFNODE: return sfnode();
    case SFROTATION: return sfrotation();
    case SFSTRING: return sfstring();
    case SFTIME: return sftime();
    case SFVEC2F: return sfvec2f();
    case SFVEC3F: return sfvec3f();
    default:    throw new InternalError( "Kind = "+kind );
    }
  }

  final public void nodeBodyElement(ParserNode node) throws ParseException {
    Token id, is;
    Route r;
    Proto p;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IS:
        jj_consume_token(IS);
        is = jj_consume_token(IDENTIFIER);
                                   scene.is( this, node, id, is );
        break;
      default:
        jj_la1[17] = jj_gen;
        fieldValue(node, id);
      }
      break;
    case ROUTE:
      r = routeStatement();
                           scene.addRoute(r);
      break;
    case PROTO:
    case EXTERNPROTO:
      p = protoStatement();
                           scene.addProto(p);
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public Token fieldType() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MFCOLOR:
      jj_consume_token(MFCOLOR);
      break;
    case MFFLOAT:
      jj_consume_token(MFFLOAT);
      break;
    case MFINT32:
      jj_consume_token(MFINT32);
      break;
    case MFNODE:
      jj_consume_token(MFNODE);
      break;
    case MFROTATION:
      jj_consume_token(MFROTATION);
      break;
    case MFSTRING:
      jj_consume_token(MFSTRING);
      break;
    case MFVEC2F:
      jj_consume_token(MFVEC2F);
      break;
    case MFVEC3F:
      jj_consume_token(MFVEC3F);
      break;
    case SFBOOL:
      jj_consume_token(SFBOOL);
      break;
    case SFCOLOR:
      jj_consume_token(SFCOLOR);
      break;
    case SFFLOAT:
      jj_consume_token(SFFLOAT);
      break;
    case SFIMAGE:
      jj_consume_token(SFIMAGE);
      break;
    case SFINT32:
      jj_consume_token(SFINT32);
      break;
    case SFNODE:
      jj_consume_token(SFNODE);
      break;
    case SFROTATION:
      jj_consume_token(SFROTATION);
      break;
    case SFSTRING:
      jj_consume_token(SFSTRING);
      break;
    case SFTIME:
      jj_consume_token(SFTIME);
      break;
    case SFVEC2F:
      jj_consume_token(SFVEC2F);
      break;
    case SFVEC3F:
      jj_consume_token(SFVEC3F);
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return getToken(0);}
    throw new Error("Missing return statement in function");
  }

  void fieldValue(ParserNode node, Token id) throws ParseException {
    if( node == null )
        unknownFieldValue();
    else {
        int type = node.getFieldType(id.image);
        if( type == -1 )
            warning( id, "no such field" );
        else {
            Field field = parseFieldKind( type );
            if( field != null )
                node.setField(id.image, field);
        }
    }
  }

//
// Generalized field parsers
//
  final public void unknownFieldValue() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
      break;
    case FALSE:
      jj_consume_token(FALSE);
      break;
    case NULL:
      jj_consume_token(NULL);
      break;
    case INTEGER:
    case FLOAT:
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FLOAT:
          jj_consume_token(FLOAT);
          break;
        case INTEGER:
          jj_consume_token(INTEGER);
          break;
        default:
          jj_la1[20] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[21] = jj_gen;
          break label_7;
        }
      }
      break;
    case STRING:
      jj_consume_token(STRING);
      break;
    case DEF:
    case USE:
    case SCRIPT:
    case IDENTIFIER:
      nodeStatement();
      break;
    case LBRACKET:
      unknownMFieldValue();
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void unknownMFieldValue() throws ParseException {
    jj_consume_token(LBRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEF:
    case USE:
    case SCRIPT:
    case INTEGER:
    case FLOAT:
    case STRING:
    case IDENTIFIER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING:
        jj_consume_token(STRING);
        label_8:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case STRING:
            ;
            break;
          default:
            jj_la1[23] = jj_gen;
            break label_8;
          }
          jj_consume_token(STRING);
        }
        break;
      case INTEGER:
      case FLOAT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FLOAT:
          jj_consume_token(FLOAT);
          break;
        case INTEGER:
          jj_consume_token(INTEGER);
          break;
        default:
          jj_la1[24] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        label_9:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INTEGER:
          case FLOAT:
            ;
            break;
          default:
            jj_la1[25] = jj_gen;
            break label_9;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FLOAT:
            jj_consume_token(FLOAT);
            break;
          case INTEGER:
            jj_consume_token(INTEGER);
            break;
          default:
            jj_la1[26] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      case DEF:
      case USE:
      case SCRIPT:
      case IDENTIFIER:
        nodeStatement();
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DEF:
          case USE:
          case SCRIPT:
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[27] = jj_gen;
            break label_10;
          }
          nodeStatement();
        }
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[29] = jj_gen;
      ;
    }
    jj_consume_token(RBRACKET);
  }

  final public int integer() throws ParseException {
                  Token i;
    i = jj_consume_token(INTEGER);
      {if (true) return ((IntegerToken)i).value;}
    throw new Error("Missing return statement in function");
  }

  final public float number() throws ParseException {
                   float f; Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FLOAT:
      t = jj_consume_token(FLOAT);
                    f = (float)((FloatToken)t).value;
      break;
    case INTEGER:
      t = jj_consume_token(INTEGER);
                    f = ((IntegerToken)t).value;
      break;
    default:
      jj_la1[30] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

  final public double numberd() throws ParseException {
                     double d; Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      t = jj_consume_token(INTEGER);
                    d = ((IntegerToken)t).value;
      break;
    case FLOAT:
      t = jj_consume_token(FLOAT);
                  d = ((FloatToken)t).value;
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return d;}
    throw new Error("Missing return statement in function");
  }

//
// Field parsers
//
  final public SFBool sfbool() throws ParseException {
                    boolean b;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
               b=true;
      break;
    case FALSE:
      jj_consume_token(FALSE);
                b=false;
      break;
    default:
      jj_la1[32] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return new SFBool(b);}
    throw new Error("Missing return statement in function");
  }

  final public SFColor sfcolor() throws ParseException {
                      float r,g,b;
    r = number();
    g = number();
    b = number();
      {if (true) return new SFColor( r, g, b );}
    throw new Error("Missing return statement in function");
  }

  final public MFColor mfcolor() throws ParseException {
                      float r, g, b; MFColor c = new MFColor();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      r = number();
      g = number();
      b = number();
                                         c.addValue(r,g,b);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[33] = jj_gen;
          break label_11;
        }
        r = number();
        g = number();
        b = number();
                                               c.addValue(r,g,b);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[34] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  final public SFFloat sffloat() throws ParseException {
                      float f;
    f = number();
      {if (true) return new SFFloat(f);}
    throw new Error("Missing return statement in function");
  }

  final public MFFloat mffloat() throws ParseException {
                      float f; MFFloat mf = new MFFloat();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      f = number();
                   mf.addValue(f);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_12:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[35] = jj_gen;
          break label_12;
        }
        f = number();
                         mf.addValue(f);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFImage sfimage() throws ParseException {
                      int w, h, nc, c, i=0; byte image[];
    w = integer();
    // width
        h = integer();
    // height
        nc = integer();
      image = new byte[w*h*nc];
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER:
        ;
        break;
      default:
        jj_la1[37] = jj_gen;
        break label_13;
      }
      c = integer();
            // All of this could be pulled out of the loop
            if( i < image.length ) {
                switch(nc) {
                case 4: image[i++] = (byte)(c >> 24);
                case 3: image[i++] = (byte)(c >> 16);
                case 2: image[i++] = (byte)(c >> 8);
                case 1: image[i++] = (byte)c;
                }
            } // else warn?

    }
      {if (true) return new SFImage( w, h, nc, image );}
    throw new Error("Missing return statement in function");
  }

  final public SFInt32 sfint32() throws ParseException {
                      int i;
    i = integer();
      {if (true) return new SFInt32(i);}
    throw new Error("Missing return statement in function");
  }

  final public MFInt32 mfint32() throws ParseException {
                      int i; MFInt32 mf = new MFInt32();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      i = integer();
                    mf.addValue(i);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_14:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
          ;
          break;
        default:
          jj_la1[38] = jj_gen;
          break label_14;
        }
        i = integer();
                          mf.addValue(i);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[39] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFNode sfnode() throws ParseException {
                    ParserNode n=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NULL:
      jj_consume_token(NULL);
               n=null;
      break;
    case DEF:
    case USE:
    case SCRIPT:
    case IDENTIFIER:
      n = nodeStatement();
      break;
    default:
      jj_la1[40] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return n==null?null:new SFNode(n);}
    throw new Error("Missing return statement in function");
  }

  final public MFNode mfnode() throws ParseException {
                    ParserNode n; MFNode mf = new MFNode();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEF:
    case USE:
    case SCRIPT:
    case IDENTIFIER:
      n = nodeStatement();
                          if( n != null ) mf.addValue(n);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_15:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DEF:
        case USE:
        case SCRIPT:
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[41] = jj_gen;
          break label_15;
        }
        n = nodeStatement();
                               if( n != null ) mf.addValue(n);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[42] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFRotation sfrotation() throws ParseException {
                            float x,y,z,a;
    x = number();
    y = number();
    z = number();
    a = number();
      {if (true) return new SFRotation(x,y,z,a);}
    throw new Error("Missing return statement in function");
  }

  final public MFRotation mfrotation() throws ParseException {
    float x,y,z,a;
    MFRotation mf = new MFRotation();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      x = number();
      y = number();
      z = number();
      a = number();
                                                   mf.addValue(x,y,z,a);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_16:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[43] = jj_gen;
          break label_16;
        }
        x = number();
        y = number();
        z = number();
        a = number();
                                                         mf.addValue(x,y,z,a);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFString sfstring() throws ParseException {
                        Token t;
    t = jj_consume_token(STRING);
      {if (true) return new SFString( ((StringToken)t).value );}
    throw new Error("Missing return statement in function");
  }

  final public MFString mfstring() throws ParseException {
                        Token t; MFString mf = new MFString();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      t = jj_consume_token(STRING);
                   mf.addValue( ((StringToken)t).value );
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_17:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRING:
          ;
          break;
        default:
          jj_la1[45] = jj_gen;
          break label_17;
        }
        t = jj_consume_token(STRING);
                       mf.addValue( ((StringToken)t).value );
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFTime sftime() throws ParseException {
                    Token t; double f;
    f = numberd();
      {if (true) return new SFTime(f);}
    throw new Error("Missing return statement in function");
  }

  final public MFTime mftime() throws ParseException {
                    double d; MFTime mf = new MFTime();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      d = numberd();
                    mf.addValue(d);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[47] = jj_gen;
          break label_18;
        }
        d = numberd();
                         mf.addValue(d);
      }
      jj_consume_token(RBRACKET);
      {if (true) return mf;}
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public SFVec2f sfvec2f() throws ParseException {
                      float x,y;
    x = number();
    y = number();
      {if (true) return new SFVec2f(x,y);}
    throw new Error("Missing return statement in function");
  }

  final public MFVec2f mfvec2f() throws ParseException {
                      float x,y; MFVec2f mf = new MFVec2f();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      x = number();
      y = number();
                              mf.addValue(x,y);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_19:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[49] = jj_gen;
          break label_19;
        }
        x = number();
        y = number();
                                   mf.addValue(x,y);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  final public SFVec3f sfvec3f() throws ParseException {
                      float x,y,z;
    x = number();
    y = number();
    z = number();
      {if (true) return new SFVec3f(x,y,z);}
    throw new Error("Missing return statement in function");
  }

  final public MFVec3f mfvec3f() throws ParseException {
                      float x,y,z; MFVec3f mf = new MFVec3f();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOAT:
      x = number();
      y = number();
      z = number();
                                         mf.addValue(x,y,z);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
        case FLOAT:
          ;
          break;
        default:
          jj_la1[51] = jj_gen;
          break label_20;
        }
        x = number();
        y = number();
        z = number();
                                              mf.addValue(x,y,z);
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[52] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return mf;}
    throw new Error("Missing return statement in function");
  }

  public VRMLParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[53];
  final private int[] jj_la1_0 = {0x2878,0x2878,0x2060,0x18,0x780,0x780,0x780,0x0,0x0,0x780,0x2000,0x818,0xb98,0x4000,0x4000,0x4000,0xb98,0x4000,0x818,0xffff8000,0x0,0x0,0x2060,0x0,0x0,0x0,0x0,0x2060,0x2060,0x2060,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2060,0x2060,0x2060,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x200,0x200,0x200,0x0,0x0,0x0,0x0,0x100,0x1100,0x0,0x200,0x200,0x200,0x0,0x0,0x0,0x200,0x0,0x200,0x3,0x60,0x60,0x137c,0x100,0x60,0x60,0x60,0x200,0x360,0x360,0x60,0x60,0xc,0x60,0x1060,0x60,0x1060,0x20,0x20,0x1020,0x210,0x200,0x1200,0x60,0x1060,0x100,0x1100,0x60,0x1060,0x60,0x1060,0x60,0x1060,};

  public VRMLParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new VRMLParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 53; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 53; i++) jj_la1[i] = -1;
  }

  public VRMLParser(VRMLParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 53; i++) jj_la1[i] = -1;
  }

  public void ReInit(VRMLParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 53; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[50];
    for (int i = 0; i < 50; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 53; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 50; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
