/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class AudioClip extends ParserNode {
    SFString description = new SFString();
    SFBool loop = new SFBool(false);
    SFFloat pitch = new SFFloat(1.0f);
    SFTime startTime = new SFTime(0);
    SFTime stopTime = new SFTime(0);
    MFString url = new MFString();
    public int getFieldType(String n) {
        if("description".equals(n)) return 30;
        if("loop".equals(n)) return 23;
        if("pitch".equals(n)) return 25;
        if("startTime".equals(n)) return 31;
        if("stopTime".equals(n)) return 31;
        if("url".equals(n)) return 20;
        return -1;
    }
    public void setField(String n, Field f) {
        if("description".equals(n)) description=(SFString)f;
        else if("loop".equals(n)) loop=(SFBool)f;
        else if("pitch".equals(n)) pitch=(SFFloat)f;
        else if("startTime".equals(n)) startTime=(SFTime)f;
        else if("stopTime".equals(n)) stopTime=(SFTime)f;
        else if("url".equals(n)) url=(MFString)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        AudioClip n = (AudioClip)super.cloneThru(i,f);
        n.description = (SFString)cloneField(description);
        n.loop = (SFBool)cloneField(loop);
        n.pitch = (SFFloat)cloneField(pitch);
        n.startTime = (SFTime)cloneField(startTime);
        n.stopTime = (SFTime)cloneField(stopTime);
        n.url = (MFString)cloneField(url);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"AudioClip {");
        dumpField(i2,out,"description",description);
        dumpField(i2,out,"loop",loop);
        dumpField(i2,out,"pitch",pitch);
        dumpField(i2,out,"startTime",startTime);
        dumpField(i2,out,"stopTime",stopTime);
        dumpField(i2,out,"url",url);
        out.println(indent+"}");
    }
    public String getType() { return "AudioClip"; }
}
