/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Color extends ParserNode {
    MFColor color = new MFColor();
    public int getFieldType(String n) {
        if("color".equals(n)) return 15;
        return -1;
    }
    public void setField(String n, Field f) {
        if("color".equals(n)) color=(MFColor)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Color n = (Color)super.cloneThru(i,f);
        n.color = (MFColor)cloneField(color);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Color {");
        dumpField(i2,out,"color",color);
        out.println(indent+"}");
    }
    public String getType() { return "Color"; }
}
