/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;
import berkeley.cs.dmc.ji3d.*;

public class Coordinate extends ParserNode {
    MFVec3f point = new MFVec3f();
    public int getFieldType(String n) {
        if("point".equals(n)) return 22;
        return -1;
    }
    public void setField(String n, Field f) {
        if("point".equals(n)) point=(MFVec3f)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Coordinate n = (Coordinate)super.cloneThru(i,f);
        n.point = (MFVec3f)cloneField(point);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Coordinate {");
        dumpField(i2,out,"point",point);
        out.println(indent+"}");
    }
    public String getType() { return "Coordinate"; }

    // Additions follow
    Vec3 points[];
    public void build() {
        points = build( point );
    }
    public void render( berkeley.cs.dmc.vrml.RenderState state ) {}
}
