/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Cylinder extends ParserNode {
    SFBool bottom = new SFBool(true);
    SFFloat height = new SFFloat(2f);
    SFFloat radius = new SFFloat(1f);
    SFBool side = new SFBool(true);
    SFBool top = new SFBool(true);
    public int getFieldType(String n) {
        if("bottom".equals(n)) return 23;
        if("height".equals(n)) return 25;
        if("radius".equals(n)) return 25;
        if("side".equals(n)) return 23;
        if("top".equals(n)) return 23;
        return -1;
    }
    public void setField(String n, Field f) {
        if("bottom".equals(n)) bottom=(SFBool)f;
        else if("height".equals(n)) height=(SFFloat)f;
        else if("radius".equals(n)) radius=(SFFloat)f;
        else if("side".equals(n)) side=(SFBool)f;
        else if("top".equals(n)) top=(SFBool)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Cylinder n = (Cylinder)super.cloneThru(i,f);
        n.bottom = (SFBool)cloneField(bottom);
        n.height = (SFFloat)cloneField(height);
        n.radius = (SFFloat)cloneField(radius);
        n.side = (SFBool)cloneField(side);
        n.top = (SFBool)cloneField(top);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Cylinder {");
        dumpField(i2,out,"bottom",bottom);
        dumpField(i2,out,"height",height);
        dumpField(i2,out,"radius",radius);
        dumpField(i2,out,"side",side);
        dumpField(i2,out,"top",top);
        out.println(indent+"}");
    }
    public String getType() { return "Cylinder"; }
}
