/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class CylinderSensor extends ParserNode {
    SFBool autoOffset = new SFBool(true);
    SFFloat diskAngle = new SFFloat(0.262f);
    SFBool enabled = new SFBool(true);
    SFFloat maxAngle = new SFFloat(-1f);
    SFFloat minAngle = new SFFloat(0f);
    SFFloat offset = new SFFloat(0f);
    public int getFieldType(String n) {
        if("autoOffset".equals(n)) return 23;
        if("diskAngle".equals(n)) return 25;
        if("enabled".equals(n)) return 23;
        if("maxAngle".equals(n)) return 25;
        if("minAngle".equals(n)) return 25;
        if("offset".equals(n)) return 25;
        return -1;
    }
    public void setField(String n, Field f) {
        if("autoOffset".equals(n)) autoOffset=(SFBool)f;
        else if("diskAngle".equals(n)) diskAngle=(SFFloat)f;
        else if("enabled".equals(n)) enabled=(SFBool)f;
        else if("maxAngle".equals(n)) maxAngle=(SFFloat)f;
        else if("minAngle".equals(n)) minAngle=(SFFloat)f;
        else if("offset".equals(n)) offset=(SFFloat)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        CylinderSensor n = (CylinderSensor)super.cloneThru(i,f);
        n.autoOffset = (SFBool)cloneField(autoOffset);
        n.diskAngle = (SFFloat)cloneField(diskAngle);
        n.enabled = (SFBool)cloneField(enabled);
        n.maxAngle = (SFFloat)cloneField(maxAngle);
        n.minAngle = (SFFloat)cloneField(minAngle);
        n.offset = (SFFloat)cloneField(offset);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"CylinderSensor {");
        dumpField(i2,out,"autoOffset",autoOffset);
        dumpField(i2,out,"diskAngle",diskAngle);
        dumpField(i2,out,"enabled",enabled);
        dumpField(i2,out,"maxAngle",maxAngle);
        dumpField(i2,out,"minAngle",minAngle);
        dumpField(i2,out,"offset",offset);
        out.println(indent+"}");
    }
    public String getType() { return "CylinderSensor"; }
}
