/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Fog extends ParserNode {
    SFColor color = new SFColor(1f, 1f, 1f);
    SFString fogType = new SFString("LINEAR");
    SFFloat visibilityRange = new SFFloat(0f);
    public int getFieldType(String n) {
        if("color".equals(n)) return 24;
        if("fogType".equals(n)) return 30;
        if("visibilityRange".equals(n)) return 25;
        return -1;
    }
    public void setField(String n, Field f) {
        if("color".equals(n)) color=(SFColor)f;
        else if("fogType".equals(n)) fogType=(SFString)f;
        else if("visibilityRange".equals(n)) visibilityRange=(SFFloat)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Fog n = (Fog)super.cloneThru(i,f);
        n.color = (SFColor)cloneField(color);
        n.fogType = (SFString)cloneField(fogType);
        n.visibilityRange = (SFFloat)cloneField(visibilityRange);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Fog {");
        dumpField(i2,out,"color",color);
        dumpField(i2,out,"fogType",fogType);
        dumpField(i2,out,"visibilityRange",visibilityRange);
        out.println(indent+"}");
    }
    public String getType() { return "Fog"; }
}
