/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Inline extends ParserNode {
    SFVec3f bboxCenter = new SFVec3f(0f, 0f, 0f);
    SFVec3f bboxSize = new SFVec3f(-1f, -1f, -1f);
    MFString url = new MFString();
    public int getFieldType(String n) {
        if("bboxCenter".equals(n)) return 33;
        if("bboxSize".equals(n)) return 33;
        if("url".equals(n)) return 20;
        return -1;
    }
    public void setField(String n, Field f) {
        if("bboxCenter".equals(n)) bboxCenter=(SFVec3f)f;
        else if("bboxSize".equals(n)) bboxSize=(SFVec3f)f;
        else if("url".equals(n)) url=(MFString)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Inline n = (Inline)super.cloneThru(i,f);
        n.bboxCenter = (SFVec3f)cloneField(bboxCenter);
        n.bboxSize = (SFVec3f)cloneField(bboxSize);
        n.url = (MFString)cloneField(url);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Inline {");
        dumpField(i2,out,"bboxCenter",bboxCenter);
        dumpField(i2,out,"bboxSize",bboxSize);
        dumpField(i2,out,"url",url);
        out.println(indent+"}");
    }
    public String getType() { return "Inline"; }
}
