/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class LOD extends ParserNode {
    SFVec3f center = new SFVec3f(0f, 0f, 0f);
    MFFloat range = new MFFloat();
    MFNode level = new MFNode();
    public int getFieldType(String n) {
        if("center".equals(n)) return 33;
        if("range".equals(n)) return 16;
        if("level".equals(n)) return 18;
        return -1;
    }
    public void setField(String n, Field f) {
        if("center".equals(n)) center=(SFVec3f)f;
        else if("range".equals(n)) range=(MFFloat)f;
        else if("level".equals(n)) level=(MFNode)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        LOD n = (LOD)super.cloneThru(i,f);
        n.center = (SFVec3f)cloneField(center);
        n.range = (MFFloat)cloneField(range);
        n.level = cloneMFNode(level,i,f);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"LOD {");
        dumpField(i2,out,"center",center);
        dumpField(i2,out,"range",range);
        dumpField(i2,out,"level",level);
        out.println(indent+"}");
    }
    public String getType() { return "LOD"; }
}
