/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class MovieTexture extends ParserNode {
    SFBool repeatS = new SFBool(true);
    SFBool repeatT = new SFBool(true);
    SFBool loop = new SFBool(false);
    SFFloat speed = new SFFloat(1.0f);
    SFTime startTime = new SFTime(0);
    SFTime stopTime = new SFTime(0);
    MFString url = new MFString();
    public int getFieldType(String n) {
        if("repeatS".equals(n)) return 23;
        if("repeatT".equals(n)) return 23;
        if("loop".equals(n)) return 23;
        if("speed".equals(n)) return 25;
        if("startTime".equals(n)) return 31;
        if("stopTime".equals(n)) return 31;
        if("url".equals(n)) return 20;
        return -1;
    }
    public void setField(String n, Field f) {
        if("repeatS".equals(n)) repeatS=(SFBool)f;
        else if("repeatT".equals(n)) repeatT=(SFBool)f;
        else if("loop".equals(n)) loop=(SFBool)f;
        else if("speed".equals(n)) speed=(SFFloat)f;
        else if("startTime".equals(n)) startTime=(SFTime)f;
        else if("stopTime".equals(n)) stopTime=(SFTime)f;
        else if("url".equals(n)) url=(MFString)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        MovieTexture n = (MovieTexture)super.cloneThru(i,f);
        n.repeatS = (SFBool)cloneField(repeatS);
        n.repeatT = (SFBool)cloneField(repeatT);
        n.loop = (SFBool)cloneField(loop);
        n.speed = (SFFloat)cloneField(speed);
        n.startTime = (SFTime)cloneField(startTime);
        n.stopTime = (SFTime)cloneField(stopTime);
        n.url = (MFString)cloneField(url);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"MovieTexture {");
        dumpField(i2,out,"repeatS",repeatS);
        dumpField(i2,out,"repeatT",repeatT);
        dumpField(i2,out,"loop",loop);
        dumpField(i2,out,"speed",speed);
        dumpField(i2,out,"startTime",startTime);
        dumpField(i2,out,"stopTime",stopTime);
        dumpField(i2,out,"url",url);
        out.println(indent+"}");
    }
    public String getType() { return "MovieTexture"; }
}
