/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class OrientationInterpolator extends ParserNode {
    MFFloat key = new MFFloat();
    MFRotation keyValue = new MFRotation();
    public int getFieldType(String n) {
        if("key".equals(n)) return 16;
        if("keyValue".equals(n)) return 19;
        return -1;
    }
    public void setField(String n, Field f) {
        if("key".equals(n)) key=(MFFloat)f;
        else if("keyValue".equals(n)) keyValue=(MFRotation)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        OrientationInterpolator n = (OrientationInterpolator)super.cloneThru(i,f);
        n.key = (MFFloat)cloneField(key);
        n.keyValue = (MFRotation)cloneField(keyValue);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"OrientationInterpolator {");
        dumpField(i2,out,"key",key);
        dumpField(i2,out,"keyValue",keyValue);
        out.println(indent+"}");
    }
    public String getType() { return "OrientationInterpolator"; }
}
