/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class PlaneSensor extends ParserNode {
    SFBool autoOffset = new SFBool(true);
    SFBool enabled = new SFBool(true);
    SFVec2f maxPosition = new SFVec2f(-1f, -1f);
    SFVec2f minPosition = new SFVec2f(0f, 0f);
    SFVec3f offset = new SFVec3f(0f, 0f, 0f);
    public int getFieldType(String n) {
        if("autoOffset".equals(n)) return 23;
        if("enabled".equals(n)) return 23;
        if("maxPosition".equals(n)) return 32;
        if("minPosition".equals(n)) return 32;
        if("offset".equals(n)) return 33;
        return -1;
    }
    public void setField(String n, Field f) {
        if("autoOffset".equals(n)) autoOffset=(SFBool)f;
        else if("enabled".equals(n)) enabled=(SFBool)f;
        else if("maxPosition".equals(n)) maxPosition=(SFVec2f)f;
        else if("minPosition".equals(n)) minPosition=(SFVec2f)f;
        else if("offset".equals(n)) offset=(SFVec3f)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        PlaneSensor n = (PlaneSensor)super.cloneThru(i,f);
        n.autoOffset = (SFBool)cloneField(autoOffset);
        n.enabled = (SFBool)cloneField(enabled);
        n.maxPosition = (SFVec2f)cloneField(maxPosition);
        n.minPosition = (SFVec2f)cloneField(minPosition);
        n.offset = (SFVec3f)cloneField(offset);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"PlaneSensor {");
        dumpField(i2,out,"autoOffset",autoOffset);
        dumpField(i2,out,"enabled",enabled);
        dumpField(i2,out,"maxPosition",maxPosition);
        dumpField(i2,out,"minPosition",minPosition);
        dumpField(i2,out,"offset",offset);
        out.println(indent+"}");
    }
    public String getType() { return "PlaneSensor"; }
}
