/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class PointSet extends ParserNode {
    SFNode color = new SFNode();
    SFNode coord = new SFNode();
    public int getFieldType(String n) {
        if("color".equals(n)) return 28;
        if("coord".equals(n)) return 28;
        return -1;
    }
    public void setField(String n, Field f) {
        if("color".equals(n)) color=(SFNode)f;
        else if("coord".equals(n)) coord=(SFNode)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        PointSet n = (PointSet)super.cloneThru(i,f);
        n.color = cloneSFNode(color,i,f);
        n.coord = cloneSFNode(coord,i,f);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"PointSet {");
        dumpField(i2,out,"color",color);
        dumpField(i2,out,"coord",coord);
        out.println(indent+"}");
    }
    public String getType() { return "PointSet"; }
}
