/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class ProximitySensor extends ParserNode {
    SFVec3f center = new SFVec3f(0f, 0f, 0f);
    SFVec3f size = new SFVec3f(0f, 0f, 0f);
    SFBool enabled = new SFBool(true);
    public int getFieldType(String n) {
        if("center".equals(n)) return 33;
        if("size".equals(n)) return 33;
        if("enabled".equals(n)) return 23;
        return -1;
    }
    public void setField(String n, Field f) {
        if("center".equals(n)) center=(SFVec3f)f;
        else if("size".equals(n)) size=(SFVec3f)f;
        else if("enabled".equals(n)) enabled=(SFBool)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        ProximitySensor n = (ProximitySensor)super.cloneThru(i,f);
        n.center = (SFVec3f)cloneField(center);
        n.size = (SFVec3f)cloneField(size);
        n.enabled = (SFBool)cloneField(enabled);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"ProximitySensor {");
        dumpField(i2,out,"center",center);
        dumpField(i2,out,"size",size);
        dumpField(i2,out,"enabled",enabled);
        out.println(indent+"}");
    }
    public String getType() { return "ProximitySensor"; }
}
