/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class SphereSensor extends ParserNode {
    SFBool autoOffset = new SFBool(true);
    SFBool enabled = new SFBool(true);
    SFRotation offset = new SFRotation(0f, 1f, 0f, 0f);
    public int getFieldType(String n) {
        if("autoOffset".equals(n)) return 23;
        if("enabled".equals(n)) return 23;
        if("offset".equals(n)) return 29;
        return -1;
    }
    public void setField(String n, Field f) {
        if("autoOffset".equals(n)) autoOffset=(SFBool)f;
        else if("enabled".equals(n)) enabled=(SFBool)f;
        else if("offset".equals(n)) offset=(SFRotation)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        SphereSensor n = (SphereSensor)super.cloneThru(i,f);
        n.autoOffset = (SFBool)cloneField(autoOffset);
        n.enabled = (SFBool)cloneField(enabled);
        n.offset = (SFRotation)cloneField(offset);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"SphereSensor {");
        dumpField(i2,out,"autoOffset",autoOffset);
        dumpField(i2,out,"enabled",enabled);
        dumpField(i2,out,"offset",offset);
        out.println(indent+"}");
    }
    public String getType() { return "SphereSensor"; }
}
