/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Text extends ParserNode {
    MFString string = new MFString();
    SFNode fontStyle = new SFNode();
    MFFloat length = new MFFloat();
    SFFloat maxExtent = new SFFloat(0.0f);
    public int getFieldType(String n) {
        if("string".equals(n)) return 20;
        if("fontStyle".equals(n)) return 28;
        if("length".equals(n)) return 16;
        if("maxExtent".equals(n)) return 25;
        return -1;
    }
    public void setField(String n, Field f) {
        if("string".equals(n)) string=(MFString)f;
        else if("fontStyle".equals(n)) fontStyle=(SFNode)f;
        else if("length".equals(n)) length=(MFFloat)f;
        else if("maxExtent".equals(n)) maxExtent=(SFFloat)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Text n = (Text)super.cloneThru(i,f);
        n.string = (MFString)cloneField(string);
        n.fontStyle = cloneSFNode(fontStyle,i,f);
        n.length = (MFFloat)cloneField(length);
        n.maxExtent = (SFFloat)cloneField(maxExtent);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Text {");
        dumpField(i2,out,"string",string);
        dumpField(i2,out,"fontStyle",fontStyle);
        dumpField(i2,out,"length",length);
        dumpField(i2,out,"maxExtent",maxExtent);
        out.println(indent+"}");
    }
    public String getType() { return "Text"; }
}
