/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class TextureTransform extends ParserNode {
    SFVec2f center = new SFVec2f(0f, 0f);
    SFFloat rotation = new SFFloat(0f);
    SFVec2f scale = new SFVec2f(1f, 1f);
    SFVec2f translation = new SFVec2f(0f, 0f);
    public int getFieldType(String n) {
        if("center".equals(n)) return 32;
        if("rotation".equals(n)) return 25;
        if("scale".equals(n)) return 32;
        if("translation".equals(n)) return 32;
        return -1;
    }
    public void setField(String n, Field f) {
        if("center".equals(n)) center=(SFVec2f)f;
        else if("rotation".equals(n)) rotation=(SFFloat)f;
        else if("scale".equals(n)) scale=(SFVec2f)f;
        else if("translation".equals(n)) translation=(SFVec2f)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        TextureTransform n = (TextureTransform)super.cloneThru(i,f);
        n.center = (SFVec2f)cloneField(center);
        n.rotation = (SFFloat)cloneField(rotation);
        n.scale = (SFVec2f)cloneField(scale);
        n.translation = (SFVec2f)cloneField(translation);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"TextureTransform {");
        dumpField(i2,out,"center",center);
        dumpField(i2,out,"rotation",rotation);
        dumpField(i2,out,"scale",scale);
        dumpField(i2,out,"translation",translation);
        out.println(indent+"}");
    }
    public String getType() { return "TextureTransform"; }
}
