/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class TimeSensor extends ParserNode {
    SFTime cycleInterval = new SFTime(1);
    SFBool enabled = new SFBool(true);
    SFBool loop = new SFBool(false);
    SFTime startTime = new SFTime(0);
    SFTime stopTime = new SFTime(0);
    public int getFieldType(String n) {
        if("cycleInterval".equals(n)) return 31;
        if("enabled".equals(n)) return 23;
        if("loop".equals(n)) return 23;
        if("startTime".equals(n)) return 31;
        if("stopTime".equals(n)) return 31;
        return -1;
    }
    public void setField(String n, Field f) {
        if("cycleInterval".equals(n)) cycleInterval=(SFTime)f;
        else if("enabled".equals(n)) enabled=(SFBool)f;
        else if("loop".equals(n)) loop=(SFBool)f;
        else if("startTime".equals(n)) startTime=(SFTime)f;
        else if("stopTime".equals(n)) stopTime=(SFTime)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        TimeSensor n = (TimeSensor)super.cloneThru(i,f);
        n.cycleInterval = (SFTime)cloneField(cycleInterval);
        n.enabled = (SFBool)cloneField(enabled);
        n.loop = (SFBool)cloneField(loop);
        n.startTime = (SFTime)cloneField(startTime);
        n.stopTime = (SFTime)cloneField(stopTime);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"TimeSensor {");
        dumpField(i2,out,"cycleInterval",cycleInterval);
        dumpField(i2,out,"enabled",enabled);
        dumpField(i2,out,"loop",loop);
        dumpField(i2,out,"startTime",startTime);
        dumpField(i2,out,"stopTime",stopTime);
        out.println(indent+"}");
    }
    public String getType() { return "TimeSensor"; }
}
