/*
 * Copyright (C) 1998 Stephen Chenney and Jeffrey Ichnowski
 *
 * This program is free software.  You can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package berkeley.cs.dmc.vrml.parser.node;

import java.util.Hashtable;
import berkeley.cs.dmc.vrml.parser.*;
import berkeley.cs.dmc.vrml.field.*;
import berkeley.cs.dmc.vrml.Field;

public class Viewpoint extends ParserNode {
    SFString description = new SFString();
    SFFloat fieldOfView = new SFFloat(0.785398f);
    SFBool jump = new SFBool(true);
    SFRotation orientation = new SFRotation(0f, 0f, 1f, 0f);
    SFVec3f position = new SFVec3f(0f, 0f, 10f);
    public int getFieldType(String n) {
        if("description".equals(n)) return 30;
        if("fieldOfView".equals(n)) return 25;
        if("jump".equals(n)) return 23;
        if("orientation".equals(n)) return 29;
        if("position".equals(n)) return 33;
        return -1;
    }
    public void setField(String n, Field f) {
        if("description".equals(n)) description=(SFString)f;
        else if("fieldOfView".equals(n)) fieldOfView=(SFFloat)f;
        else if("jump".equals(n)) jump=(SFBool)f;
        else if("orientation".equals(n)) orientation=(SFRotation)f;
        else if("position".equals(n)) position=(SFVec3f)f;
    }
    public ParserNode cloneThru(Hashtable i, Hashtable f) {
        Viewpoint n = (Viewpoint)super.cloneThru(i,f);
        n.description = (SFString)cloneField(description);
        n.fieldOfView = (SFFloat)cloneField(fieldOfView);
        n.jump = (SFBool)cloneField(jump);
        n.orientation = (SFRotation)cloneField(orientation);
        n.position = (SFVec3f)cloneField(position);
        return n;
    }
    public void dump(String indent, java.io.PrintStream out) {
        String i2 = indent + "  ";
        out.println(indent+"Viewpoint {");
        dumpField(i2,out,"description",description);
        dumpField(i2,out,"fieldOfView",fieldOfView);
        dumpField(i2,out,"jump",jump);
        dumpField(i2,out,"orientation",orientation);
        dumpField(i2,out,"position",position);
        out.println(indent+"}");
    }
    public String getType() { return "Viewpoint"; }

    public void build() {}
    public void render( berkeley.cs.dmc.vrml.RenderState state ) {}
}
